<?php
	
# HyperB5 Next Generation
# Copyright (C) 2007-2009 HyperB5 Staff
# http://www.hyperb5.info/
#
# Basato (molto!) su HyperTrekNG 1.2 - 2.1.3
# Copyright (C) 2005-2007 HyperTrek-NG Development Team
# http://www.hypertrek.info/
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# http://www.gnu.org/copyleft/gpl.html
#
# Thanks to MediaWiki for a few lines of code and some ideas:
# Copyright (C) 2003 Brion Vibber <brion@pobox.com>
# http://www.mediawiki.org/


/*
 * Variabili globali
 *
 * Definizione delle variabili globali
 *
 *  @autore Luigi Rosa <lrosa@hypertrek.info>
 *  @modificato da Stefano Monguzzi <info@hyperb5.info>
 *  @version 0.4.5 20130603
 */

if(!defined('HYPERB5')) {
	header ('Location: http://www.hyperb5.info/');
	die();
}

/**
 * array $Setup
 * @global array $Setup parametri di configurazione della procedura di visualizzazione
 */
$Setup['doctype']         = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">'; // SGML document type
$Setup['versione']        = '0.4.5';				// versione del software
$Setup['idpaginadefault'] = 1;					// id della pagina di default
$Setup['favicon']         = '/favicon.ico';			// posizione della favicon
$Setup['charset']         = 'ISO-8859-1';			// definizione del charset ISO
$Setup['titolo']          = 'HyperB5 * ';			// titolo HTML di default
$Setup['pathimmagini']    = 'immagini/';			// path delle immagini
$Setup['pathicone']       = '/icone/';				// path delle icone
$Setup['cssfile']         = 'hyperb5.css';			// foglio stile da utilizzare
$Setup['docroot']         = '/';				// root del sito
$Setup['durata']          = 86400;				// numero di secondi di durata della pagina (24 ore)
$Setup['quantitopmenu']   = 13;					// numero di icone del topmenu	
$Setup['giornilast']      = 2592000;				// numero di secondi di vecchiaia della pagina perche' compaia nelle ultime modifiche (30 gg.)
$Setup['rsslast']         = 'ultimemodifiche.xml';		// nome del file con il feed RSS delle ultime modifiche
$Setup['cloudhm']         = 50;					// quanti elementi devono essere visualizzati nella tag cloud
$Setup['cloudpxmin']      = 10;					// dimensione minima in pixel del font nella tag cloud
$Setup['cloudpxmax']      = 40;					// dimensione massima in pixel del font nella tag cloud

// tipi delle sezioni
$tipopagina = array();
$tipopagina['generica'] = 0;		// pagina di testo generica
$tipopagina['elencopuntato'] = 1;	// pagina formata da un solo elenco puntato
$tipopagina['homepage'] = 2;		// home page
$tipopagina['episodio'] = 3;		// episodio
$tipopagina['libro'] = 4;		// libro
$tipopagina['pianeta'] = 5;		// pianeta
$tipopagina['specie'] = 6;		// specie
$tipopagina['cast'] = 7;		// cast regolare di una serie
$tipopagina['personaggio'] = 8;		// personaggio
$tipopagina['attore'] = 9;		// attore
$tipopagina['timelineb5'] = 10;		// timeline di Babylon 5
$tipopagina['errore404'] = 11;		// pagina da visualizzare per l'errore 404
$tipopagina['statistiche'] = 12;	// pagina speciale delle statistiche
$tipopagina['recurring'] = 13;		// personaggi ricorrenti
$tipopagina['tabellariass'] = 14;	// tabella riassuntiva degli episodi
$tipopagina['albero'] = 15;		// albero di navigazione
$tipopagina['novita'] = 16;		// novit del sito
$tipopagina['navi'] = 17;		// novit del sito

// tipi degli indici
$tipoindice = array();
$tipoindice['generico'] = 0;		// tutte le voci in ordine alfabetico, no frills
$tipoindice['genericotop'] = 1;		// tutte le voci in ordine alfabetico, con elenco dei sottomenu
$tipoindice['b5top'] = 2;		// Babylon 5 - Top menu
$tipoindice['b5eps'] = 3;		// Babylon 5 - Top menu episodi
$tipoindice['b5trasm'] = 4;		// Babylon 5 - Trasmissione
$tipoindice['b5prod'] = 5;		// Babylon 5 - Produzione
$tipoindice['b5us'] = 6;		// Babylon 5 - Titoli originali
$tipoindice['b5itr'] = 7;		// Babylon 5 - Titoli italiani (RAI/DVD)
$tipoindice['b5cons'] = 8;		// Babylon 5 - Consigliato
$tipoindice['b5misc'] = 9;		// Babylon 5 - varie
$tipoindice['b5toppg'] = 10;		// Babylon 5 - pagine singole nell'indice principale
$tipoindice['crutop'] = 11;		// Crusade - Top menu
$tipoindice['crueps'] = 12;		// Crusade - Top menu episodi
$tipoindice['crutrasm'] = 13;		// Crusade - Trasmissione
$tipoindice['cruprod'] = 14;		// Crusade - Produzione
$tipoindice['cruus'] = 15;		// Crusade - Titoli originali
$tipoindice['cruit'] = 16;		// Crusade - Titoli italiani
$tipoindice['crucons'] = 17;		// Crusade - Consigliato
$tipoindice['crumisc'] = 18;		// Crusade - varie
$tipoindice['crutoppg'] = 19;		// Crusade - pagine singole nell'indice principale
$tipoindice['tlttop'] = 20;		// The Lost Tales - Top menu
$tipoindice['tlteps'] = 21;		// The Lost Tales - Top menu episodi
$tipoindice['tlttrasm'] = 22;		// The Lost Tales - Uscita
$tipoindice['tltprod'] = 23;		// The Lost Tales - Produzione
$tipoindice['tltus'] = 24;		// The Lost Tales - Titoli originali
$tipoindice['tltit'] = 25;		// The Lost Tales - Titoli italiani
$tipoindice['tltcons'] = 26;		// The Lost Tales - Consigliato
$tipoindice['tltmisc'] = 27;		// The Lost Tales - varie
$tipoindice['tlttoppg'] = 28;		// The Lost Tales - pagine singole nell'indice principale
$tipoindice['filmtvtop'] = 29;		// Film TV - Top menu
$tipoindice['filmtvtrasm'] = 30;	// Film TV - Trasmissione
$tipoindice['filmtvprod'] = 31;		// Film TV - Produzione
$tipoindice['filmtvus'] = 32;		// Film TV - Titoli originali
$tipoindice['filmtvitr'] = 33;		// Film TV - Titoli italiani (RAI)
$tipoindice['filmtvcons'] = 34;		// Film TV - Consigliato
$tipoindice['filmtvmisc'] = 35;		// Film TV - varie
$tipoindice['filmtvtoppg'] = 36;	// Film TV - pagine singole nell'indice principale
$tipoindice['indice'] = 37;		// indice
$tipoindice['b5itj'] = 38;		// Babylon 5 - Titoli italiani (Canal Jimmy)
$tipoindice['filmtvitj'] = 39;		// Film TV - Titoli italiani (Canal Jimmy)

// topmenu
// velocizza la visualizzazione del menu, che tanto non cambia spesso
// la query per ottenere questa tabella e'
// SELECT node.idimmaginemenu, node.indextag FROM sezioni AS node, sezioni AS parent WHERE node.sxmenu BETWEEN parent.sxmenu AND parent.dxmenu GROUP BY node.nome HAVING (COUNT(parent.nome) - 1) = 1 ORDER BY node.sxmenu;
$TopMenu[1]['file'] = 'menu-b5.png';			$TopMenu[1]['tag'] = 'b5'; $TopMenu[1]['desc'] = 'Babylon 5';
$TopMenu[2]['file'] = 'menu-crusade.png';		$TopMenu[2]['tag'] = 'cru'; $TopMenu[2]['desc'] = 'Crusade';
$TopMenu[3]['file'] = 'menu-filmtv.png';		$TopMenu[3]['tag'] = 'filmtv'; $TopMenu[3]['desc'] = 'Film TV';
$TopMenu[4]['file'] = 'menu-libri.png';			$TopMenu[4]['tag'] = 'libri'; $TopMenu[4]['desc'] = 'Libri &amp; Fumetti';
$TopMenu[5]['file'] = 'menu-mondi.png';			$TopMenu[5]['tag'] = 'mondi'; $TopMenu[5]['desc'] = 'Mondi';
$TopMenu[6]['file'] = 'menu-specie.png';		$TopMenu[6]['tag'] = 'specie'; $TopMenu[6]['desc'] = 'Specie';
$TopMenu[7]['file'] = 'menu-organizzazioni.png';	$TopMenu[7]['tag'] = 'organizzazioni'; $TopMenu[7]['desc'] = 'Organizzazioni';
$TopMenu[8]['file'] = 'menu-navi.png';			$TopMenu[8]['tag'] = 'navi'; $TopMenu[8]['desc'] = 'Navi';
$TopMenu[9]['file'] = 'menu-tecnologia.png';		$TopMenu[9]['tag'] = 'tecnologia'; $TopMenu[9]['desc'] = 'Tecnologia';
$TopMenu[10]['file'] = 'menu-personaggi.png';		$TopMenu[10]['tag'] = 'personaggi'; $TopMenu[10]['desc'] = 'Personaggi';
$TopMenu[11]['file'] = 'menu-aes.png';			$TopMenu[11]['tag'] = 'aes'; $TopMenu[11]['desc'] = 'Attori e Staff';
$TopMenu[12]['file'] = 'menu-indice.png';		$TopMenu[12]['tag'] = 'indice'; $TopMenu[12]['desc'] = 'Indice';
$TopMenu[13]['file'] = 'menu-varie.png';		$TopMenu[13]['tag'] = 'varie'; $TopMenu[13]['desc'] = 'Varie';

?>
