<?php

# HyperB5 Next Generation
# Copyright (C) 2007-2009 HyperB5 Staff
# http://www.hyperb5.info/
#
# Basato (molto!) su HyperTrekNG 1.2 - 2.1.3
# Copyright (C) 2005-2007 HyperTrek-NG Development Team
# http://www.hypertrek.info/
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# http://www.gnu.org/copyleft/gpl.html


/**
 * Funzioni comuni
 *
 *  @autore Luigi Rosa <lrosa@hypertrek.info>
 *  @modificato da Stefano Monguzzi <info@hyperb5.info>
 *  @version 0.4.5 20130603
 *  @package visualizzatore
 *
 */

if(!defined('HYPERB5')) {
	header ('Location: http://www.hyperb5.info/');
	die();
}

/**
 * AJAXcerca($aValori)
 * 
 * Elabora le ricerche
 * 
 */

function AJAXcerca($aValori) {
	global $hb5_db_ro,$hb5_db_rw,$oPagina;	
	if (!isset ($_SESSION)) session_start();
	$oResp = new xajaxResponse();
	$oResp->assign("subCerca","disabled",false);
	$oResp->assign("subCerca","value","Cerca");
	$cercato = strip_tags(trim($aValori['cerca']));
	$aPagine = array();
	$aOut = array();
	$b = '';
	$c = 0;
	if ('' != $cercato and strlen($cercato) > 2) {
		$cercato = mysql_real_escape_string($cercato, $hb5_db_ro);
		// titoli
		$qr = mysql_query("SELECT idpagina FROM pagine WHERE titolo LIKE '%$cercato%'", $hb5_db_ro);
		while ($r = mysql_fetch_array($qr)) {
			$aPagine[] = $r['idpagina'];
	    	}
		// testi
		$qr = mysql_query("SELECT idpagina FROM testi WHERE testo LIKE '%$cercato%'", $hb5_db_ro);
		while ($r = mysql_fetch_array($qr)) {
			$aPagine[] = $r['idpagina'];
	    	}
	    	// capitoli
		$qr = mysql_query("SELECT idpagina FROM capitoli WHERE testo LIKE '%$cercato%'", $hb5_db_ro);
		while ($r = mysql_fetch_array($qr)) {
			$aPagine[] = $r['idpagina'];
	  	}
		$aPagine = array_unique($aPagine);
		// popolo l'array delle pagine
		foreach ($aPagine as $pg) {
			$rr = mysql_query("SELECT tag,titolondx,chiavesort FROM pagine WHERE idpagina=$pg", $hb5_db_ro);
			$r = mysql_fetch_array($rr);
			$aOut[] = "$r[chiavesort]|$r[titolondx]|$r[tag]";
			$c++;
		}
		// metto tutto in ordine
		asort($aOut);
		// visualizzo
		foreach ($aOut as $pg) {
			list($trash,$titolo,$tag) = explode('|', $pg);
			$b .= "\n<div class='testoindice'>" . $oPagina->espandiLink('{' . "$titolo|$tag" . '}') . '</div>';
		}
		if (0 == $c) $b .= "\n<div class='testoindice'>Nessuna pagina trovata.</div>";
			elseif (1 == $c) $b .= "\n<div class='testoindice'>Una pagina trovata.</div>";
			else $b .= "\n<div class='testoindice'>$c pagine trovate.</div>";
	} else {
		$b = "\n<div class='testoindice'>Non &egrave; stata specificata una parola da cercare o la parola &egrave; troppo corta.</div>";
	}
	$ccc = mysql_real_escape_string($aValori['cerca'], $hb5_db_rw);
	mysql_query("INSERT INTO cerca SET dataora=NOW(),cerca='$ccc',ip='$_SERVER[REMOTE_ADDR]',trovati=$c", $hb5_db_rw);
	$oResp->assign("testoindice","innerHTML", "<div class='titoloindice'>Risultato della ricerca di <em>" . HB5_accentate($cercato) ."</em></div><div class='testoindice'>" . HB5_accentate($b) . "</div>");
	return $oResp;
}


/**
 * AJAXscriviIndice($idindice)
 * 
 * Wrapper per usare la funzione di generazione dell'indice via AJAX
 * 
 * @param int $idindice indice da visualizzare, 0 per l'indice di default (home page)
 */

function AJAXscriviIndice($idindice) {
	$oResp = new xajaxResponse();
	$oResp->assign("testoindice","innerHTML", HB5_ScriviIndice($idindice));
	return $oResp;
}

/**
 * HB5_ScriviIndice($idindice)
 * 
 * Funzione principale di generazione dell'indice
 * 
 * @param int $idindice indice da visualizzare, 0 per l'indice di default (home page)
 * @todo sistemare 'sto schifo di codice degli indici delle serie
 */
function HB5_ScriviIndice($idindice) {
	global $tipoindice, $hb5_db_ro, $oPagina;
	if (!isset ($_SESSION)) session_start();
	$b = '';
	// reimposto il valore dell'indice corrente per potermelo portar dietro tra una pagina e l'altra
	$_SESSION['ndx'] = $idindice;
      	if (0 == $idindice) {
		//indice di default (ad es. per la home page) con i link rapidi
		$lrtitolo = array();
		$lrtesto = array();
		$qrd = mysql_query("SELECT categoria,riferimento
		                           FROM riferimenti 
		                           WHERE idpagina=1
		                           ORDER BY categoria,riferimento", $hb5_db_ro);
		if (mysql_num_rows($qrd) > 0) {
			while ($rd = mysql_fetch_array($qrd)) {
				array_push($lrtitolo, $rd['categoria']);
				array_push($lrtesto, $oPagina->espandiLink($rd['riferimento']));
			}
			if (count($lrtesto) > 0) {
				$b .= "<div class='contenitoreindicesezione'>";
				$b .= "<div class='titoloindice'>$lrtitolo[0]</div>";
				for ($n = 0; $n < count($lrtesto); $n++) {
					$b .= "\n<div class='testoindice'>" . $lrtesto[$n] . "</div>";
				}
				$b .= "</div>";
			}
		}			
		$qrd = mysql_query("SELECT lastmod,titolondx,titolo,tag
		                           FROM pagine
		                           WHERE hidden = 0
		                           ORDER BY lastmod DESC
		                           LIMIT 10", $hb5_db_ro);
		if (mysql_num_rows($qrd) > 0) {
			$b .= "<div class='contenitoreindicesezione'>";
			$b .= "<div class='titoloindice'>Ultime 10 pagine modificate</div>";
			while ($rd = mysql_fetch_array($qrd)) {
      				if ( '' == $rd['titolondx']) {
      					$t = $rd['titolo'];
      				} else {
      					$t = $rd['titolondx'];
      				}
      				$b .= "\n<div class='testoindice'><strong>&raquo;&nbsp;</strong> " . $oPagina->espandiLink('{' . "$t|$rd[tag]" . '}') . " (" . date('d/m/Y', $rd['lastmod']) . ")</div>";
			}
			$b .= "</div>";
		}			
      	} else {
      		$q = mysql_query("SELECT * FROM sezioni WHERE idsezione=$idindice", $hb5_db_ro);
      		$r = mysql_fetch_array($q);
      		//contenitore indice sezione
      		$b .= "<div class='contenitoreindicesezione'>";
      		//scrivo titolo dell'indice e metto una riga di spazio dopo
      		$b .= "\n<div class='titoloindice'>$r[nome]</div>";
      		// mi serve per capire la sottosezione da visualizzare
      		$idsezione = $r['idsezione'];
      		// mi serve per le astronavi e l'indice alfabetico
      		$indextag = $r['indextag'];
      		// and so it begins....
      		switch ($r['tipoindice']) {
			case $tipoindice['generico']:
			case $tipoindice['b5misc']:
			case $tipoindice['crumisc']:
			case $tipoindice['filmtvmisc']:
			case $tipoindice['genericotop']:
			case $tipoindice['alfabeticotop']:
      				//una sola query incasinata e ho (quasi) tutto quello che mi serve
      				$qrd = mysql_query("SELECT node.nome, node.indextag, (COUNT(parent.idsezione) - (sub_tree.depth + 1)) AS depth
                                                          FROM sezioni AS node,
                                                          	sezioni AS parent,
                                                          	sezioni AS sub_parent,
                                                          	(
                                                          		SELECT node.idsezione, (COUNT(parent.idsezione) - 1) AS depth
                                                          		FROM sezioni AS node,
                                                          		sezioni AS parent
                                                          		WHERE node.sxmenu BETWEEN parent.sxmenu AND parent.dxmenu
                                                          		AND node.idsezione = $idindice
                                                          		GROUP BY node.idsezione
                                                          		ORDER BY node.sxmenu
                                                          	)AS sub_tree
                                                          WHERE node.sxmenu BETWEEN parent.sxmenu AND parent.dxmenu
                                                          	AND node.sxmenu BETWEEN sub_parent.sxmenu AND sub_parent.dxmenu
                                                          	AND sub_parent.idsezione = sub_tree.idsezione
                                                          GROUP BY node.idsezione
                                                          HAVING depth = 1
                                                          ORDER BY node.sxmenu", $hb5_db_ro);
      				while ($rd = mysql_fetch_array($qrd)) {
      					$b .= "\n<div class='testosottoindici'>" . $oPagina->espandiLink( '{' . $rd['nome'] . '|:' . $rd['indextag'] . '}') . '</div>';
      				}
      				$qrd = mysql_query("SELECT titolondx,titolo,tag 
      				                         FROM pagine 
      				                         WHERE idsezione=$idindice AND hidden=0 
      				                         ORDER BY chiavesort", $hb5_db_ro);
      				while ($rd = mysql_fetch_array($qrd)) {
      					if ( '' == $rd['titolondx']) {
      						$t = $rd['titolo'];
      					} else {
      						$t = $rd['titolondx'];
      					}
      					$b .= "\n<div class='testoindice'>" . $oPagina->espandiLink('{' . "$t|$rd[tag]" . '}') . '</div>';
      				}
      			break;
      			// Babylon 5 top menu
      			case $tipoindice['b5top']:
      				$b .= HB5_ndxTop('b5', $tipoindice['b5misc'], $idsezione);
      			break;
      			// Babylon 5 top menu episodi
      			case $tipoindice['b5eps']:
      				$b .= HB5_ndxTop('b5');
      			break;
      			// Babylon 5 trasmissione
      			case $tipoindice['b5trasm']:
      				$b .= HB5_ndxEpisodi(2, 'trasm');
      			break;
      			// Babylon 5 produzione
      			case $tipoindice['b5prod']:
      				$b .= HB5_ndxEpisodi(2, 'prod');
      			break;
      			// Babylon 5 titoli originali
      			case $tipoindice['b5us']:
      				$b .= HB5_ndxTitoliOriginali(3);
      			break;
      			// Babylon 5 titoli italiani (RAI/DVD)
      			case $tipoindice['b5itr']:
      				$b .= HB5_ndxTitoliItaliani(3,0);
      			break;
      			// Babylon 5 titoli italiani (Canal Jimmy)
      			case $tipoindice['b5itj']:
      				$b .= HB5_ndxTitoliItaliani(3,1);
      			break;
      			// Babylon 5 ordine consigliato
      			case $tipoindice['b5cons']:
      				$b .= HB5_ndxEpisodi(2, 'cons');
      			break;
      			// Crusade top menu
      			case $tipoindice['crutop']:
      				$b .= HB5_ndxTop('cru', $tipoindice['crumisc'], $idsezione);
      			break;
      			// Crusade top menu episodi
      			case $tipoindice['crueps']:
      				$b .= HB5_ndxTop('cru', 0, 0);
      			break;
      			// Crusade trasmissione
      			case $tipoindice['crutrasm']:
      				$b .= HB5_ndxEpisodi(9, 'trasm');
      			break;
      			// Crusade produzione
      			case $tipoindice['cruprod']:
      				$b .= HB5_ndxEpisodi(9, 'prod');
      			break;
      			// Crusade titoli originali
      			case $tipoindice['cruus']:
      				$b .= HB5_ndxTitoliOriginali(10);
      			break;
      			// Crusade titoli italiani
      			case $tipoindice['cruit']:
      				$b .= HB5_ndxTitoliItaliani(10,0);
      			break;
      			// Crusade ordine consigliato
      			case $tipoindice['crucons']:
      				$b .= HB5_ndxEpisodi(9, 'cons');
      			break;
      			// Film TV top menu
      			case $tipoindice['filmtvtop']:
      				$b .= HB5_ndxTop('filmtv', $tipoindice['filmtvmisc'], $idsezione);
      			break;
      			// Film TV trasmissione
      			case $tipoindice['filmtvtrasm']:
      				$b .= HB5_ndxEpisodi(16, 'trasm');
      			break;
      			// Film TV produzione
      			case $tipoindice['filmtvprod']:
      				$b .= HB5_ndxEpisodi(16, 'prod');
      			break;
      			// Film TV titoli originali
      			case $tipoindice['filmtvus']:
      				$b .= HB5_ndxTitoliOriginali(16);
      			break;
      			// Film TV titoli italiani (RAI)
      			case $tipoindice['filmtvitr']:
      				$b .= HB5_ndxTitoliItaliani(16,0);
      			break;
      			// Film TV titoli italiani (Canal Jimmy)
      			case $tipoindice['filmtvitj']:
      				$b .= HB5_ndxTitoliItaliani(16,1);
      			break;
      			// Film TV ordine consigliato
      			case $tipoindice['filmtvcons']:
      				$b .= HB5_ndxEpisodi(16, 'cons');
      			break;
      			// indice (quello vero!)
      			case $tipoindice['indice']:
      				$chelettera = substr($indextag, 7, 1);
      				if ('0' == $chelettera) {
      					$qi = mysql_query("( SELECT idpagina,chiavesort 
      					                            FROM pagine 
      					                            WHERE chiavesort<>'' AND hidden=0 AND (LEFT(TRIM(chiavesort),1)<'a' OR LEFT(TRIM(chiavesort),1)>'z'))
      					                          ORDER BY chiavesort", $hb5_db_ro);
      				} else {
      					$qi = mysql_query("( SELECT idpagina,chiavesort 
      					                            FROM pagine 
      					                            WHERE chiavesort<>'' AND hidden=0 AND LEFT(TRIM(chiavesort),1)='$chelettera') 
      					                          ORDER BY chiavesort", $hb5_db_ro);
      				}
      				while ($ri = mysql_fetch_array($qi)) {
      					$rrp = mysql_query("SELECT titolo,titolondx,tag FROM pagine WHERE idpagina=$ri[idpagina]", $hb5_db_ro);
      					$rp = mysql_fetch_array($rrp);
      					if ( '' == $rp['titolondx']) {
      						$t = $rp['titolo'];
      					} else {
      						$t = $rp['titolondx'];
      					}
      					if ('' != $rp['tag']) {
      						$b .= "\n<div class='testoindice'>" . $oPagina->espandiLink('{' . "$t|$rp[tag]" . '}') . '</div>';
      					}
      				}
      			break;
      	
      		}
      		$b .= "</div>"; //chiuso contenitoreindicesezione
      	}
	//formatta l'output
	return HB5_accentate($b);
}



/**
 * HB5_ndxTop($serie, $subndx, $paginesingole)
 * 
 * Crea l'inizio del topmenu di una serie
 * 
 * @param string $serie tag dell'indice della serie
 * @param integer $subndx id del tipo dell'indice dei sottoindici da referenziare nell'indice
 * @param integer $idsez id della sezione dell'indice chiamante
 */
function HB5_ndxTop($serie, $subndx=9999, $idsez=9999) {
	global $hb5_db_ro,$oPagina;
	if (!isset ($_SESSION)) session_start();
	$b = '';
	$b .= "\n<div class='testosottoindici'>" . $oPagina->espandiLink( '{Ordine di trasmissione|:' . $serie .'trasm}') . '</div>';
	$b .= "\n<div class='testosottoindici'>" . $oPagina->espandiLink( '{Ordine di produzione|:' . $serie .'prod}') . '</div>';
	$b .= "\n<div class='testosottoindici'>" . $oPagina->espandiLink( '{Ordine alfabetico|:' . $serie . 'us}') . '</div>';
	if (('b5' == $serie) OR ('filmtv' == $serie)) { //Babylon 5 e Film TV - Crusade non ha i titoli italiani (per ora)
	$b .= "\n<div class='testosottoindici'>" . $oPagina->espandiLink( '{Titoli italiani (RAI)|:' . $serie . 'itr}') . '</div>';
	$b .= "\n<div class='testosottoindici'>" . $oPagina->espandiLink( '{Titoli italiani (Canal Jimmy)|:' . $serie . 'itj}') . '</div>';
	}
	$b .= "\n<div class='testosottoindici'>" . $oPagina->espandiLink( '{Ordine consigliato|:' . $serie . 'cons}') . '</div>';
	// altri submenu
	if ('' != $subndx) {
          	$qrd = mysql_query("SELECT nome,indextag 
          	                         FROM sezioni 
          	                         WHERE tipoindice=$subndx 
          	                         ORDER BY sxmenu", $hb5_db_ro);
          	while ($rd = mysql_fetch_array($qrd)) {
          		$b .= "\n<div class='testosottoindici'>" . $oPagina->espandiLink('{' . "$rd[nome]|:$rd[indextag]" . '}') . '</div>';
          	}
	}
	// pagine singole
	if ('' != $idsez) {
		//per i filmtv  un po' diverso perch non c' la sezione episodi quindi isoliamo le pagine singole (escludiamo pagine di tipo "episodio")
		if ('filmtv' == $serie) {
			$qrd = mysql_query("SELECT titolondx,chiavesort,tag,tipo 
				                  FROM pagine WHERE idsezione=$idsez AND hidden=0 AND tipo != 3
				                  ORDER BY chiavesort", $hb5_db_ro);
		} else {	
			$qrd = mysql_query("SELECT titolondx,chiavesort,tag 
				                  FROM pagine WHERE idsezione=$idsez AND hidden=0 
				                  ORDER BY chiavesort", $hb5_db_ro);
		}
        	if (mysql_num_rows($qrd) > 0) {
        		while ($rd = mysql_fetch_array($qrd)) {
        			$b .= "\n<div class='testoindice'>" . $oPagina->espandiLink('{' . "$rd[titolondx] | $rd[tag]" . '}') . '</div>';
        		}
        	}
	}
	return $b;
}


/**
 * HB5_ndxTitoliOriginali($sezione)
 * 
 * Crea l'elenco dei titoli originali di una serie
 * 
 * @param integer $sezione id della sezione (serie) da visualizzare
 */
function HB5_ndxTitoliOriginali($sezione) {
	global $hb5_db_ro,$oPagina;
	$b = '';
	if ('16' == $sezione) { //per i Film TV (sez. 16)  un po' diverso
        	$qrd = mysql_query("SELECT titolondx,chiavesort,tag 
        	                         FROM pagine 
        	                         JOIN listaepisodi ON pagine.idpagina = listaepisodi.idpagina
        	                         WHERE serie=$sezione AND hidden=0 
        	                         ORDER BY chiavesort", $hb5_db_ro);
        } else {
        	$qrd = mysql_query("SELECT titolondx,chiavesort,tag 
        	                         FROM pagine 
        	                         JOIN listaepisodi ON pagine.idpagina = listaepisodi.idpagina
        	                         WHERE idsezione=$sezione AND hidden=0 
        	                         ORDER BY chiavesort", $hb5_db_ro);
        }
	while ($rd = mysql_fetch_array($qrd)) {
		$b .=  "\n<div class='testoindice'><strong>&raquo;&nbsp;</strong> " . $oPagina->espandiLink('{' . "$rd[titolondx]|$rd[tag]" . '}') . '</div>';
	}
	return $b;
}


/**
 * ndxTitoliItaliani($sezione,$alternate)
 * 
 * Crea l'elenco dei titoli italiani di una serie
 * 
 * @param integer $sezione id della sezione (serie) da visualizzare
 * @param integer $alternate titoli alternativi (0 = RAI, 1 = Canal Jimmy)
 */
function HB5_ndxTitoliItaliani($sezione, $alternate) {
	global $hb5_db_ro,$oPagina;
	$b = '';
	// modo veloce per selezionare i titoli versione Jimmy (campo 21) o RAI (campo 11) 
	if ('1' == $alternate) { $campo = '21'; }
	else { $campo = '11'; }
	$qrd = mysql_query("SELECT pagine.tag,episodivalori.valore,pagine.idpagina 
	                         FROM pagine 
	                         JOIN episodivalori ON pagine.idpagina=episodivalori.idpagina
	                         WHERE idsezione=$sezione AND idcampo=$campo AND hidden=0
	                         ORDER BY episodivalori.chiavesortita", $hb5_db_ro);
	while ($rd = mysql_fetch_array($qrd)) {
		$b .= "\n<div class='testoindice'><strong>&raquo;&nbsp;</strong> " . $oPagina->espandiLink('{' . strip_tags($rd[valore]) . '|' . $rd[tag] . '}') . '</div>';
	}
	if ('0' == $alternate) {
		$b .= "\n<br><div class='testosottoindici'>N.B.: non tutti gli episodi/film hanno un titolo italiano (secondo il doppiaggio versione \"RAI\").</div>";
	}
	return $b;
}


/**
 * HB5_ndxEpisodi($sezione, $ordinamento)
 * 
 * Crea l'elenco dei titoli in ordine di produzione di una serie
 * 
 * @param integer $sezione id della sezione (serie) da visualizzare
 * @param text $ordinamento tipo di ordinamento da utilizzare: prod, trasm, cons
 */
function HB5_ndxEpisodi($sezione, $ordinamento) {
	global $hb5_db_ro,$oPagina;
	$b = '';
	$ordine = '';
	// stabiliamo l'ordinamento da utilizzare
	switch ($ordinamento) {
	case 'prod':
		$ordine = 'ordineproduzione';
		break;
	case 'trasm':
		$ordine = 'ordinetrasmissione';
		break;
	case 'cons':
		$ordine = 'ordineconsigliato';
		break;
	}
	// innanzi tutto i[l] pilot
	$qrd = mysql_query("SELECT stagione,serie,pagine.tag,pagine.idpagina,pagine.titolondx
	                        FROM pagine 
	                        JOIN listaepisodi ON pagine.idpagina=listaepisodi.idpagina
	                        WHERE serie=$sezione AND stagione='P' AND hidden=0
	                        ORDER BY $ordine", $hb5_db_ro);
	if (mysql_num_rows($qrd) > 0) {
		$b .= "\n<div class='sottotitoliindice'>Pilot</div>";
		while ($rd = mysql_fetch_array($qrd)) {
			$b .= "\n<div class='testoindice'><strong>&raquo;&nbsp;</strong> " . $oPagina->espandiLink('{' . "$rd[titolondx]|$rd[tag]" . '}') . '</div>';
		}
	}
	//stagione regolare
	$qrd = mysql_query("SELECT stagione,serie,pagine.tag,pagine.idpagina,pagine.titolondx,episodivalori.valore,indextag
	                         FROM pagine 
	                         JOIN listaepisodi ON pagine.idpagina=listaepisodi.idpagina
	                         JOIN episodivalori ON pagine.idpagina=episodivalori.idpagina
	                         JOIN sezioni ON listaepisodi.serie=sezioni.idsezione
	                         WHERE serie=$sezione AND idcampo=1 AND stagione<>'P' AND hidden=0
	                         ORDER BY $ordine", $hb5_db_ro);
	$stagione = "*";
	while ($rd = mysql_fetch_array($qrd)) {
		// rottura di stagione
		if ($rd['stagione'] != $stagione) {
			if ('' != $rd['stagione']) {
				//controllo se c' la pagina descrittiva della stagione - il metodo  un po' incasinato e da rifare ASAP
				$tagstag = $rd['indextag'] . "-s" . $rd['stagione'];
				$r = mysql_query("SELECT idpagina FROM pagine WHERE tag='$tagstag'", $hb5_db_ro);
				if (mysql_num_rows($r) > 0) {
					$b .= "\n<div class='sottotitoliindice'>" . $oPagina->espandiLink('{Stagione ' . "$rd[stagione]|$tagstag" . '}') . "</div>";
				} else {
					$b .= "\n<div class='sottotitoliindice'>Stagione $rd[stagione]</div>";
				}
			}
		}
		// per i Film TV (sezione 16) niente numero di produzione prima del titolo
		if ('16' == $sezione) {
			$b .= "\n<div class='testoindice'><strong>&raquo;&nbsp;</strong> " . $oPagina->espandiLink('{' . "$rd[titolondx]|$rd[tag]" . '}') . '</div>';
		} else {
			$b .= "\n<div class='testoindice'><strong>&raquo;&nbsp;</strong> " . $oPagina->espandiLink('{' . "$rd[valore] - $rd[titolondx]|$rd[tag]" . '}') . '</div>';
		}
		$stagione = $rd['stagione'];
	}
	return $b;
}


/**
 * HB5_accentate($s)
 * 
 * Sostituisce le lettere accentate con i relativi codici HTML. Serve ad aggirare un problema di IE7 con la libreria xajax.
 * 
 * @param string $s stringa da analizzare
 */

function HB5_accentate($s) {
	$aFrom = array('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '');
	$aTo = array('&agrave;', '&aacute;', '&acirc;', '&auml;', '&Egrave;', '&egrave;', '&eacute;', '&ecirc;', '&euml;', '&igrave;', '&iacute;', '&icirc;', '&iuml;', '&ograve;', '&oacute;', '&ocirc;', '&ouml;', '&ugrave;', '&uacute;', '&ucirc;', '&uuml;', '&laquo;', '&raquo;', '&sup2;', '&ccedil;', '&ntilde;', '&szlig;', '&iquest;', '&frac12;', '&copy;');
	$retval = str_replace($aFrom, $aTo, $s);
	return $retval;
}


?>
