<?php

# HyperB5 Next Generation
# Copyright (C) 2007-2009 HyperB5 Staff
# http://www.hyperb5.info/
#
# Basato (molto!) su HyperTrekNG 1.2 - 2.1.3
# Copyright (C) 2005-2007 HyperTrek-NG Development Team
# http://www.hypertrek.info/
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# http://www.gnu.org/copyleft/gpl.html
#
# Thanks to MediaWiki for a few lines of code and some ideas:
# Copyright (C) 2003 Brion Vibber <brion@pobox.com>
# http://www.mediawiki.org/

/**
 *  Visualizzatore della pagina html
 *  @autore Luigi Rosa <lrosa@hypertrek.info>
 *  @modificato da Stefano Monguzzi <info@hyperb5.info>
 *  @version 0.4.5 20130603
 */


/**
 * Include con la classe pagina
 */
 
//protezione
if(!defined('HYPERB5')) {
	header ('Location: http://www.hyperb5.info/');
	die();
}

//set locale
setlocale(LC_ALL, 'it_IT', 'it');

/**
 * Classe che visualizza la pagina online
 *
 * La classe pagina contiene il codice per la visualizzazione
 * online delle pagine di HB5.<br>
 * Il costruttore dell'oggetto inizializza le variabili, mentre
 * l'unico metodo esportato, scrivi, visualizza la pagina.
 *
 */

class hb5_pagina {
	var $aPagina;      // array con i campi della tabella pagine
	var $aRifTitolo;   // Titolo riferimenti all'interno della pagina
	var $aRifTesto;    // Testo riferimenti all'interno della pagina
	var $aSezione;     // array con i campi della tabella sezioni
	var $aSetup;       // array con i dati di setup
	var $idpagina;     // id SQL della pagina o anno se la pagina e' della timeline, utilizzare SOLAMENTE in fase di inizializzazione
	var $idindice;     // identificatore dell'indice da visualizzare
	var $rwdb;         // database read/write
	var $rquri;        // Request URI, serve per loggarlo in caso di bad request
	var $ref;          // Referrer, serve per loggarlo in caso di bad request
	var $motd;         // messaggio del giorno da visualizzare in basso a destra
	var $dbro;         // database read-only
	var $dbrw;         // database read-write
	var $iscronologia; // flag che mi dice se la pagina che devo visualizzate e' della cronologia di Babylon 5
	var $skin;     // path relativo alla root della skin corrente

	/**
	 * Costruttore
	 * 
	 * Inizializzazione delle variabili interne all'oggetto e 
	 * decisione su quale sia la pagina da visualizzare in base
	 * ai parametri passati.
	 * 
	 * @param string $tag tag della pagina
	 * @param string $ruri usato per loggare eventuali errori
	 * @param string $rref usato per loggare eventuali errori
	 * @global string $path_stili path dei fogli stile
	 * @global string $path_icone path delle icone
	 * @global resource $hb5_db_rw handle della risorsa del database MySQL abilitato alla scrittura
	 * @global resource $hb5_db_ro handle della risorsa del database MySQL read-only
	 * @global array $Setup array con le varie voci di configurazione del programma
	 * @global object $xajax oggetto xajax
	 */
	function hb5_pagina($tag, $ruri, $rref) {
		global $path_stili, $path_icone, $hb5_db_ro, $hb5_db_rw, $Setup, $TopMenu, $xajax;
		$this->aSetup       = $Setup;
		$this->aTopMenu     = $TopMenu;
		$this->aRifTitolo   = array();
		$this->aRifTesto    = array();
		$this->rquri        = $ruri;
		$this->ref          = $rref;
		$this->motd         = '';
		$this->dbro         = $hb5_db_ro;
		$this->dbrw         = $hb5_db_rw;
		$this->iscronologia = FALSE;
		$this->ajax         = $xajax;
		$this->skin         = $this->aSetup['docroot'] . 'skin/' . $_SESSION['skin'] . '/';
		// iniziamo con i default
		$this->idpagina = $this->aSetup['idpaginadefault'];
		// indice
		if (0 != $_SESSION['ndx']) {
			// controllo se l'ID dell'indice e' valido
			$qr = mysql_query("SELECT idsezione FROM sezioni WHERE idsezione='$_SESSION[ndx]'", $this->dbro);
			if (mysql_num_rows($qr) < 1) {
				$this->loggaBad('NDX ' . $ndx);
				$_SESSION['ndx'] = 0;
			}
		}
		// se mi e' stato passato un tag
		if('' != $tag) {
				$qr = mysql_query("SELECT idpagina FROM pagine WHERE tag='$tag'", $this->dbro);
				if (mysql_num_rows($qr) > 0) {
					$r = mysql_fetch_array($qr);
					$this->idpagina = $r[0];
				} else {
					$this->loggaBad('TAG ' . $tag);
				}
				$this->aggiornaStatistiche($this->idpagina, FALSE);
		}
	}


	/**
	 * scrivi()
	 * 
	 * Funzione di output HTML via http
	 * Invia anche alcuni header http
	 * 
	 * @global array $tipopagina tipi di pagina
	 */
	function scrivi() {
		global $tipopagina;
		$rd = mysql_query("SELECT * FROM pagine WHERE idpagina=$this->idpagina", $this->dbro);
		$this->aPagina = mysql_fetch_array($rd);
		$rd = mysql_query("SELECT stagione FROM listaepisodi WHERE idpagina=$this->idpagina", $this->dbro);
		if (mysql_num_rows($rd) > 0) {
			$r = mysql_fetch_array($rd);
			$this->aPagina['stagione'] = $r[0];
		}
		// se il campo IMDb e' valorizzato, aggiungo il riferimento
		if ('' != $this->aPagina['imdb']) {
			$this->aggiungiRiferimento('Link esterni', $this->espandiLink("{IMDb|@". $this->aPagina['imdb'] ."}"));
		}
		$rd = mysql_query("SELECT * FROM sezioni WHERE idsezione=" . $this->aPagina['idsezione'], $this->dbro);
		$this->aSezione = mysql_fetch_array($rd);
		if ('' == $this->aSezione['icona']) {
			$rd = mysql_query("SELECT parent.icona
						FROM sezioni AS node, sezioni AS parent
						WHERE node.sxmenu BETWEEN parent.sxmenu AND parent.dxmenu
						AND node.idsezione = " . $this->aPagina['idsezione'] . "
						ORDER BY parent.sxmenu
						LIMIT 1,1", $this->dbro);
			$r = mysql_fetch_array($rd);
			$this->aSezione['icona'] = $r[0];
		}
		// header HTTP e HTML
		$this->intestazione();
		echo "\n<body>";
		// anchor per tornare all'inizio
		echo "\n<a name='top'></a>";		
		// barra di navigazione che sta in una sua tabella a parte
		$this->topMenu();

		// contenitore di tutta la pagina
		echo "\n<table class='contenitorepagina'>";
		echo "\n<tbody><tr>";
		
		//contenitore colonna di sinistra
		echo "\n<td class='contenitorecolonnasx'>";
		// tabella per la colonna di sinistra
		echo "\n<table class='colonnasx'><tbody>";
		// prima di tutto una riga per "estetica"
		echo "\n<tr><td class='colonnasxtop'>";
		echo "&nbsp;";
		echo "</td></tr>";
		// poi l'indice
		echo "\n<tr><td class='contenitoreindice'>";
		echo "\n<div id='testoindice'>";
		echo HB5_ScriviIndice($_SESSION['ndx']);
		echo "</div>"; // chiuso testoindice
		echo "</td></tr>"; // chiuso contenitoreindice
		echo "</tbody></table></td>"; // chiuso contenitorecolonnasx

		// bufferizzazione della parte testuale della colonna principale
		// dati
		// decido la struttura dei dati da visualizzare
		$bb = "\n<div class='testopagina'>";
		switch ($this->aPagina['tipo']) {
		case $tipopagina['generica']:
			$bb .= $this->testiStandard();
			$bb .= $this->capitoli();
			break;
		case $tipopagina['specie']:
			$bb .= $this->immaginiAltoDx();
			$bb .= $this->testiStandard();
			$bb .= $this->capitoli();
			break;
		case $tipopagina['episodio']:
			$bb .= $this->datiEpisodio();
			$bb .= $this->testiStandard();
			$bb .= $this->capitoli();
			$this->motd = '{Legenda delle abbreviazioni delle tabelle | legenda}.';
			break;
		case $tipopagina['cronologia']:
			$bb .= $this->cronologiaB5();
			break;
		case $tipopagina['personaggio']:
			$bb .= $this->immaginiAltoDx();
			$bb .= $this->calcolaAttoriPersonaggio();
			$bb .= $this->calcolaApparizioniPersonaggio();
			$bb .= $this->testiStandard();
			$bb .= $this->capitoli();
			break;
		case $tipopagina['cast']:
			$bb .= $this->immaginiAltoDx();
			$bb .= $this->testiStandard();
			break;
		case $tipopagina['libro']:
			$bb .= $this->datiEpisodio();
			$bb .= $this->testiStandard();
			$bb .= $this->capitoli();
			$this->motd = '{Legenda delle abbreviazioni delle tabelle | legenda}.';
			break;
		case $tipopagina['attore']:
			$bb .= $this->immaginiAltoDx();
			$bb .= $this->apparizioniCast();
			$bb .= $this->testiStandard();
			$bb .= $this->capitoli();
			break;
		case $tipopagina['statistiche']:
			$bb .= $this->testiStandard();
			$bb .= $this->statisticheDelSito();
			break;
		case $tipopagina['homepage']:
			$this->aggiornaUltimi();
			$this->ultime10Pagine();
			$bb .= $this->scriviHomePage();
			break;
		case $tipopagina['elencopuntato']:
			$bb .= $this->capitoli('tuttapagina');
			break;
		case $tipopagina['pianeta']:
			$bb .= $this->immaginiAltoDx();
//			$bb .= $this->datiEpisodio();
			$bb .= $this->testiStandard();
			$bb .= $this->capitoli();
			$this->motd = '{Legenda delle abbreviazioni delle tabelle | legenda}.';
			break;
		case $tipopagina['recurring']:
			$bb .= $this->recurringCharacters();
			break;
		case $tipopagina['errore404']:
			$bb .= $this->testiStandard();
			$bb .= $this->capitoli();
			// codice da Google per la ricerca - va messo qui qui perche' ci sono le parentesi degli stili
			$bb .= '<style type="text/css">
					#goog-wm {margin-top: 2em; margin-left: 5px; margin-right: 5px; border: thin dotted #c00000;}
					#goog-wm h3.closest-match { }
					#goog-wm h3.closest-match a { }
					#goog-wm h3.other-things { }
					#goog-wm ul li { }
					#goog-wm li.search-goog { display: block; }
					</style>
					<script type="text/javascript">
					var GOOG_FIXURL_LANG = \'it\';
					var GOOG_FIXURL_SITE = \'http://www.hyperb5.info/\';
					</script>
					<script type="text/javascript" src="http://linkhelp.clients.google.com/tbproxy/lh/wm/fixurl.js"></script>';
			break;
		case $tipopagina['albero']:
			$bb .= $this->testiStandard();
			$bb .= $this->mappaDelSito();
			$bb .= $this->capitoli();
			break;
		case $tipopagina['novita']:
			$bb .= $this->testiStandard();
			$bb .= $this->novita();
			break;
		case $tipopagina['navi']:
			$this->calcolaClasseNave();
			$bb .= $this->testiStandard();
			$bb .= $this->capitoli();
			break;
		}
		$bb .= "\n</div>"; // chiuso testopagina

		// colonna principale con i contenuti
		echo "\n<td class='contenitoretesto'>";
		// la homepage non ha barra del titolo
		if ($this->aPagina['tipo'] != $tipopagina['homepage']) {
			// contenitore del titolo, icone sezione ed eventuali pulsanti avanti/indietro
			echo "\n<table class='testotitolo'><tbody><tr>";
			// icona della sezione della pagina ed eventuale stagione
			echo $this->iconaSezione();
			// titolo della pagina
			echo "<td class='testotitolotesto'>" . HB5_accentate($this->aPagina['titolo']) . "</td>";
			// frecce di navigazione, se ci sono
			echo $this->frecceNavigazione();
			echo "\n</tr></tbody></table>"; // chiuso testotitolo
		}

		// testo della pagina bufferizzato precedentemente
		echo HB5_accentate($bb);
		echo "\n</td>"; // chiuso contenitoretesto

		//contenitore colonna di destra
		echo "\n<td class='contenitorecolonnadx'>";
		// tabella per la colonna di sinistra
		echo "\n<table class='colonnadx'><tbody>";
		// prima di tutto una riga per "estetica"
		echo "\n<tr><td class='colonnadxtop'>";
		echo "&nbsp;";
		echo "</td></tr>";
		// poi il form di ricerca
		echo "\n<tr><td class='formricerca'>";
		echo "<form id='frmCerca' method='post' action='javascript:void(null);' onsubmit='HB5cerca();'><div class='cerca'>";
		echo "<input class='cercatext' type='text' name='cerca' size='10' maxlength='30'> ";
		echo "<input id='subCerca' class='cercabtn' type='submit' value='Cerca'>";
		echo "</div></form></td></tr>"; // chiusi cerca e formricerca

		echo "\n<tr><td class='contenitoreriferimenti'>";
		// poi inseriamo i riferimenti, tranne in home page dove non sono previsti
		if ($this->aPagina['tipo'] != $tipopagina['homepage']) {
			echo HB5_accentate($this->scriviRiferimenti());
		}
		echo "</td></tr>"; // chiuso contenitoreriferimenti
		echo "</tbody></table></td>"; // chiuso contenitorecolonnadx

		echo "\n</tr></tbody></table>"; //chiuso contenitorepagina

		// footer
		echo "\n<table class='contenitorefooter'><tbody>";
		echo $this->pieDiPagina();
		echo "\n</tbody></table>"; //chiuso contenitorefooter

		// chiusura HTML
		echo "\n</body>\n</html>";

/*		// una volta fatto tutto, sostituisco i caratteri speciali con gli equivalenti codici html
		echo HB5_accentate($this->op); */
	}


	/**
	 * intestazione()
	 * 
	 * Output degli header HTTP e HTML
	 * 
	 */
	function intestazione() {
		global $tipopagina;
		// elaboro le richieste xajax
		$this->ajax->processRequest();
		// se e' la pagina speciale per la gestione dell'errore 404, mando un 404 prima di mandare altri header
		if ($this->aPagina['tipo'] == $tipopagina['errore404']) {
			header("HTTP/1.0 404 Not Found");
		}
		header("Content-Type: text/html; charset=" . $this->aSetup['charset']);
		header("Last-Modified: " . date('r',$this->aPagina['lastmod']));
		header("Expires: " . date('r', time() + $this->aSetup['durata']));
		echo $this->aSetup['doctype'];
		echo "\n<html lang='it'>";
		echo "\n<head>";
		if ('main' == $this->aPagina['tag']) {
			echo "\n<title>" . $this->aSetup['titolo'] . strip_tags($this->aSezione['nome']) . '</title>';
		} else {
			echo "\n<title>" . $this->aSetup['titolo'] . strip_tags($this->aSezione['nome']) . ' * ' . strip_tags($this->aPagina['titolo']) . '</title>';
		}
		echo "\n<link rel='STYLESHEET' href='" . $this->skin . $this->aSetup['cssfile'] . "' type='text/css'>";
		echo "\n<!--[if lte IE 7]><script src='" . $this->skin . "IE8.js' type='text/javascript'></script><![endif]-->";
		echo "\n<link rel='SHORTCUT ICON' HREF='" . $this->aSetup['favicon'] . "'>";
		echo "\n<meta http-equiv='Content-Type' content='text/html; charset=" . $this->aSetup['charset'] . "'>";
		echo "\n<meta name='generator' content='HyperB5-NG Content Engine v" . $this->aSetup['versione'] . " based on HyperTrek:NG Content Engine v1.2-2.0 by HyperTrek-NG Development Team'>";
		echo "\n<link rel='alternate' title='HyperB5: ultime modifiche' href='http://www.hyperb5.info/" . $this->aSetup['rsslast'] . "' type='application/rss+xml'>";
		//funzioni AJAX
		echo "\n";
		echo $this->ajax->printJavascript($this->aSetup['docroot'] . 'xajax/');
		echo "<script type='text/javascript'>
		function HB5cerca(){
			xajax.$('subCerca').disabled=true;
			xajax.$('subCerca').value=\"Attendere...\";
			xajax_AJAXcerca(xajax.getFormValues('frmCerca'));
			return false;
		}
		</script>";
		echo "\n</head>";
	}

	
	/**
	 * topMenu()
	 * 
	 * Output della barra di navigazione con tutta la sua tabella
	 * 
	 */
	function topMenu() {
		echo "\n<table class='barranavigazionecont'><tbody><tr><td>";

		//prima riga: icone del topmenu
		echo "\n<table class='barranavigazioneicone'><tbody><tr>";
		// icona di apertura a sinistra
		$zz = $this->costruisciURLImmagineSkin('menu-logo.png', 'HyperB5') . '>';
		// copertina e' un link speciale per azzerare la visualizzazione degli indici
		echo "<td class='barranavigazionesx'>" . $this->espandiLink('{' . $zz . "| copertina}") . "</td>";
		// icone
		for ($n = 1; $n <= $this->aSetup['quantitopmenu']; $n++) {
			echo "<td class='barranavigazionecn'>";
			$i = $this->costruisciURLImmagineSkin($this->aTopMenu[$n]['file'], $this->aTopMenu[$n]['desc']) . '>';
			echo $this->espandiLink( '{' . $i . '|:' . $this->aTopMenu[$n]['tag'] . '}');
			echo "</td>";
		}
		// tappo a destra
		$rd = mysql_query("SELECT autore, nome FROM skin WHERE dir='$_SESSION[skin]'", $this->dbro);
		$r = mysql_fetch_array($rd);
		$aut = "Skin: " . $r['nome'] . ", by " . $r['autore'];
		echo "<td class='barranavigazionedx'>" . $this->costruisciURLImmagineSkin('menu-tappo.png', $aut) . "></td>";
		echo "</tr></tbody></table>"; // chiuso barranavigazioneicone
		echo "</td></tr>";

		//seconda riga: breadcrumb
		echo "\n<tr><td class='barranavigazionebreadcrumb'>";
		if ($this->aPagina['tag'] != 'main') {
			$bb = '';
			$idsezb = '';
			$separatore = ' &gt; ';
			$datogliere = -6;
			$bb = "<span class='breadcrumb'>Sei in: ";
			//metto la home page che c' sempre
			$bb .= $this->espandiLink('{Home Page|copertina}') . $separatore;
			//controllo se la sezione ha un suo breadcrumb o se si basa sul proprio parent
			if ($this->aSezione['idsezionebreadcrumb'] != '0') {
				$idsezb = $this->aSezione['idsezionebreadcrumb'];
			} else {
				$idsezb = $this->aSezione['idsezione'];
			}
			//manicomio per trovare i breadcrumb
			$qrd = mysql_query("SELECT parent.sigla, parent.indextag
								FROM sezioni AS node, sezioni AS parent
								WHERE node.sxbreadcrumb BETWEEN parent.sxbreadcrumb AND parent.dxbreadcrumb
								AND node.idsezione = $idsezb
								ORDER BY parent.sxbreadcrumb", $this->dbro);
			while ($rd = mysql_fetch_array($qrd)) {
				if ('main' != $rd['indextag']) {
					//costruisco la successione dei breadcrumb
					$bb .= $this->espandiLink( '{' . $rd['sigla'] . '|:' . $rd['indextag'] . '}') . $separatore;
				}
			}
			$bb .= $this->aPagina['titolo'] . $separatore;
			$bb = substr($bb, 0, $datogliere);
			echo $bb;
			echo "</span>";
		} else {
			echo "<span class='breadcrumb'>Sei in: Home Page</span>";
		}
		echo "</td></tr>"; //chiuso barranavigazionebreadcrumb

		echo "</tbody></table>"; //chiuso barranavigazionecont
	}


	/** 
	 * iconaSezione()
	 * 
	 * Icona della sezione ed eventuale icona della stagione.
	 * 
	 */
	function iconaSezione() {
		$b = '';
		// c'e' l'icona della sezione?
		if ('' != trim($this->aSezione['icona'])) {
			$b .= "\n<td class='testoiconasezione'>";
			$b .= $this->espandiLink( '{' . $this->costruisciURLImmagineSkin($this->aSezione['icona'], $this->aSezione['nome']) . '>' . '|:' . $this->aSezione['indextag'] . '}');
			$b .= "</td>"; //chiuso testoiconasezione
		}
		// c'e' l'icona della stagione?
		if ('' != $this->aPagina['stagione']) {
			switch ($this->aPagina['stagione']) {
			case '1':
				$icona = 'icona-stagione1.png';
				$desc = 'Stagione 1';
				break;
			case '2':
				$icona = 'icona-stagione2.png';
				$desc = 'Stagione 2';
				break;
			case '3':
				$icona = 'icona-stagione3.png';
				$desc = 'Stagione 3';
				break;
			case '4':
				$icona = 'icona-stagione4.png';
				$desc = 'Stagione 4';
				break;
			case '5':
				$icona = 'icona-stagione5.png';
				$desc = 'Stagione 5';
				break;
			case 'P':
				$icona = 'icona-stagionepilot.png';
				$desc = 'Pilot';
				break;
			}
			$b .= "\n<td class='testoiconastagione'>";
			$b .= $this->costruisciURLImmagineSkin($icona, $desc). '>';
			$b .= "</td>"; //chiuso testoiconastagione
		}
		return $b;
	}


	/** 
	 * frecceNavigazione()
	 * 
	 * Frecce di navigazione
	 * 
	 * @global array $tipopagina tipi di pagina
	 */
	function frecceNavigazione() {
		$b = "\n<td class='testofreccenavigazione'>";
		// se e' necessario visualizzare le icone <> di navigazione
		if ('' != $this->aPagina['tagprima'] or '' != $this->aPagina['tagdopo']) {
			// icona episodio precedente
			if ('' != $this->aPagina['tagprima']) {
				$ttr = mysql_query("SELECT titolo FROM pagine WHERE tag='" . $this->aPagina['tagprima'] . "'", $this->dbro);
				$tr = mysql_fetch_array($ttr);
				$zz = str_replace("'", "&#39;", $tr[0]);
				$b .= $this->espandiLink('{' . $this->costruisciURLImmagineSkin('icona-frecciasx.png', $zz) . '>|' . $this->aPagina['tagprima'] . '}');
			} else {
				$b .= $this->costruisciURLImmagineSkin('icona-frecciasxno.png', 'Nessun episodio precedente') . '>';
			}
			// icona episodio successivo
			if ('' != $this->aPagina['tagdopo']) {
				$ttr = mysql_query("SELECT titolo FROM pagine WHERE tag='" . $this->aPagina['tagdopo'] . "'", $this->dbro);
				$tr = mysql_fetch_array($ttr);
				$zz = str_replace("'", "&#39;", $tr[0]);
				$b .= $this->espandiLink('{' . $this->costruisciURLImmagineSkin('icona-frecciadx.png', $zz) . '>|' . $this->aPagina['tagdopo'] . '}');
			} else {
				$b .= $this->costruisciURLImmagineSkin('icona-frecciadxno.png', 'Nessun episodio successivo') . '>';
			}
		}
		$b .= "</td>"; //chiuso testofreccenavigazione
		return $b;
	}


	/**
	 * immaginiAltoDx()
	 * 
	 * Visualizza le immagini in alto a destra nella pagina
	 * 
	 */

	function immaginiAltoDx() {
		$iad = '';
		//controlla se ci sono immagini e nel caso crea il relativo contenitore
		$qrd = mysql_query("SELECT * FROM immagini
							RIGHT JOIN immaginipagine ON immagini.idimmagine=immaginipagine.idimmagine
							WHERE immaginipagine.idpagina=" . $this->aPagina['idpagina'] . "
							ORDER BY ordine", $this->dbro);
		if (mysql_num_rows($qrd) > 0) {
			$aimg = array();
			while ($rd = mysql_fetch_array($qrd)) {
				$bz = '';
				if ('' == $rd['tagrotante']) {
					$bz .= $this->costruisciURLimmagine($rd['file'], $rd['descrizione']);
					$bz .= " width='$rd[larghezza]' height='$rd[altezza]' class='altodx'>";
				} else {
					$imgtag = $this->espandiLink('{|#' . $rd['tagrotante'] . '}');
					$bz .= str_replace( '<img' , "<img class='altodx' ", $imgtag);
				}
				$aimg[] = $bz;
			}
			$iad = "\n<div class='immaginialtodx'>\n";
			$iad .= implode('<br>', $aimg);
			$iad .= "\n</div>"; //chiuso immaginialtodx
		} else {
			$iad = '';
		}
		return $iad;
	}


	/**
	 * datiEpisodio()
	 * 
	 * Visualizza la tabella di un episodio con i dati e i guest
	 * 
	 */
	function datiEpisodio() {
		$b = '';
		// contenitore esterno della tabelle con le tabelle dei dati e dei guest
		$b .= "\n<div class='episodiocontenitoredatiguest'>";

		// contenitore interno tabella dei dati
		$b .= "\n<div class='episodiocontenitoredati'>";
		//tabella dei dati episodio
		$aeti = array();
		$aval = array();
		$aimg = array();
		$aimgd = array();
		$conta = 0;
		$qrd = mysql_query("SELECT etichetta,valore,tag,titolondx,idpaginacast,icona,descrizione
							FROM episodivalori
							JOIN episodicampi on episodivalori.idcampo=episodicampi.idcampo
							LEFT JOIN pagine on episodivalori.idpaginacast=pagine.idpagina
							WHERE episodivalori.idpagina=" . $this->aPagina['idpagina'] . "
							ORDER BY episodicampi.ordine,episodivalori.ordine", $this->dbro);
		$b .= "\n<table class='datiepisodio'><tbody>";
		while ($rd = mysql_fetch_array($qrd)) {
			//stabilisco se e' un valore 'cablato' oppure 'tabellato'
			if ( '' != $rd['tag'] ) {
				//gestisco la possibilita' di mettere uno pseudonimo
				if ('' == trim($rd['valore'])) {
					$valore = '{' . $rd['titolondx'] . '|' . $rd['tag'] . '}';
				} else {
					$valore = '{' . $rd['valore'] . '|' . $rd['tag'] . '}';
				}	
			} else {
				$valore = $rd['valore'];
			}
			// se e' un altro valore dello stesso campo accodo il valore e non incremento il contatore
			if ($aeti[$conta] == $rd['etichetta'] . ":") {
				$aval[$conta] .= "<br>$valore";
			} else {
				$conta++;
				$aeti[$conta] = $rd['etichetta'] . ":";
				$aimg[$conta] = $rd['icona'];
				$aimgd[$conta] = str_replace("'", "&#39;", $rd['descrizione']);
				$aval[$conta] = $valore;
			}
		}
		for ($i=1; $i<=$conta; $i++) {
			$b .= "\n<tr><td class='datiepisodioicona'>";
			// vedo se c'e' un'icona per l'item che sto visualizzando
			if ('' == $aimg[$i]) {
				$b .= "<strong title='" . $aimgd[$i] . "'>" . $aeti[$i] . "</strong>";			
			} else {
				$b .= $this->costruisciURLimmagineSkin($aimg[$i], $aimgd[$i]) . '>';				
			}
			$b .= "</td><td class='datiepisodiotesto'>" . $this->espandiLink($aval[$i]) . "</td></tr>";
		}
		$b .= "\n</tbody></table>";
		$b .= "</div>"; //chiuso episodiocontenitoredati

		// contenitore interno tabella dei guest
		$b .= "\n<div class='episodiocontenitoreguest'>";
		$aper = array();
		$aatt = array();
		$conta = 0;
		$qrd = mysql_query("SELECT personaggio,nomeattore,p1.tag AS ptag,p2.tag AS ctag,p1.titolondx AS ptitolondx,p2.titolondx AS ctitolondx 
							FROM guest
							LEFT JOIN pagine AS p1 ON guest.idpaginapersonaggio=p1.idpagina
							LEFT JOIN pagine AS p2 ON guest.idpaginacast=p2.idpagina
							WHERE guest.idpagina=" . $this->aPagina['idpagina'] . " AND uncredited='0' AND iscastfisso='0' 
							ORDER BY ordine", $this->dbro);
		while ($rd = mysql_fetch_array($qrd)){
			//gestisco la possibilit che l'attore abbia il credit con un nome diverso da quello nella sua scheda
			if ('' == $rd['nomeattore']) {
				$attore= '{' . $rd['ctitolondx'] . '|' . $rd['ctag'] . '}';
			} else {
				$attore= '{' . $rd['nomeattore'] . '|' . $rd['ctag'] . '}';
			}
			//gestisco la possibilita' di listare il personaggio con un nome diverso pur mantenendo il link
			if ( '' == $rd['ptag'] ) {
				$personaggio = $rd['personaggio'];
			} else {
				if ('' == trim($rd['personaggio'])) {
					// nome di default
					$personaggio = '{' . $rd['ptitolondx'] . '|' . $rd['ptag'] . '}';
				} else {
					// override, decido se devo espandere il nome con il meta '@@@'
					if (strpos($rd['personaggio'], '@@@') === FALSE) {
						$personaggio = '{' . $rd['personaggio'] . '|' . $rd['ptag'] . '}';
					} else {
						$z = '{' . $rd['ptitolondx'] . '|' . $rd['ptag'] . '}';
						$personaggio = str_replace('@@@', $z, $rd['personaggio']);
					}
				}
			}
/*			// se e' un altro attore per lo stesso personaggio accodo il valore e non incremento il contatore
			if ($aper[$conta] == $personaggio) {
				$aatt[$conta] .= "<br>$attore";
			} else { */
				$conta++;
				$aper[$conta] = $personaggio;
				$aatt[$conta] = $attore;
/*			} */
		}
		if ($conta>0) {
			$b .= "\n<table class='guestepisodio'><tbody>";
			for ($i=1; $i<=$conta; $i++) {
				$b .= "\n<tr>";
				//se si tratta di un Film TV (idsezione=16) c' tutto il cast al posto dei soli guest (ma l'icona rimane la stessa)
				if (('16' != $this->aSezione['idsezione']) AND (1 === $i)) {
					$b .= "<td class='guestepisodioicona' rowspan='$conta'>" . $this->costruisciURLimmagineSkin('icona-guest.png', 'Guest') . "></td>";
				} elseif (('16' == $this->aSezione['idsezione']) AND (1 === $i)) {
					$b .= "<td class='guestepisodioicona' rowspan='$conta'>" . $this->costruisciURLimmagineSkin('icona-guest.png', 'Cast del Film TV') . "></td>";
				}
//				if (1 < $i) { $b .= "<td class='guestepisodioicona'>&nbsp;</td>"; }
				$b .= "<td class='guestepisodiotesto'>" . $this->espandiLink($aper[$i]) . "</td><td class='guestepisodiotesto'><strong>" . $this->espandiLink($aatt[$i]) . "</strong></td></tr>";
			}
			$b .= "\n</tbody></table>";
		} else {
			$b .= "\n&nbsp;";
		}
		$b .= "</div>"; //chiuso episodiocontenitoreguest
		$b .= "\n</div>"; // chiuso episodiocontenitoredatiguest
		return $b;
	}


	/**
	 * testiStandard($opzionidiv)
	 * 
	 * Visualizza le parti di testo generico senza intestazione
	 * 
	 * @param string $opzionidiv parametri opzionali del tag <div> (tipicamente gli stili)
	 */
	function testiStandard($opzionidiv='') {
//		$b = "\n<div class='testostandardcontenitore'>";
		$qrd = mysql_query("SELECT * FROM testi WHERE idpagina=" . $this->aPagina['idpagina'] . " ORDER BY ordine", $this->dbro);
		while ($rd = mysql_fetch_array($qrd)){
			//se contiene un elenco puntato non usa il tag <p> (nel caso si utilizzino gli elenchi puntati, nel campo 'testo' del database inserire il codice html corretto e comprensivo di eventuali stili css)
			if (false === strpos($rd['testo'], '<ul>')) {
				if ('' == $opzionidiv) {
					if ('' == $rd['class']) {
						$b .= "\n<div class='testostandard'>";
					} else {
						$b .= "\n<div class='$rd[class]'>";
					}
				} else {
					$b .= "\n<div $opzionidiv>";
				}
				$b .= $this->espandiLink($rd['testo']) . "</div>";
			} else {
				$b .= "\n" . $this->espandiLink($rd['testo']);
			}
		}
//		$b .= "\n</div>"; //chiuso testostandardcontenitore
		return $b;
	}


	/**
	 * capitoli($tipo)
	 * 
	 * Visualizza le parti di testo con intestazione
	 * 
	 * @param string $tipo se assente mostra un normale paragrafo con intestazione se vale 'tuttapagina' mostra un elenco puntato a tutta pagina
	 */
	function capitoli($tipo='') {
		$b = "\n<div class='testocapitolo'>";
		switch ($tipo) {
			case '':
				//array con i riferimenti ai capitoli da stampare
				$aCapitoli = array();
				$qrd = mysql_query("SELECT idcapitolo,capitoli.idcapitolotipo AS tipo,capitoli.ordine AS cordine,capitolitipi.ordine AS tordine,isbullet 
									FROM capitoli
									JOIN capitolitipi ON capitoli.idcapitolotipo=capitolitipi.idcapitolotipo 
									WHERE idpagina=" . $this->aPagina['idpagina'], $this->dbro);
				while ($rd = mysql_fetch_array($qrd)) {
					$aCapitoli[] = str_pad($rd['tordine'], 8, ' ', STR_PAD_LEFT) . '|' . str_pad($rd['cordine'], 8, ' ', STR_PAD_LEFT). "|$rd[tipo]|$rd[idcapitolo]|$rd[isbullet]|0";
				}
				// vediamo se ci sono riferimenti inversi
				$qrd = mysql_query("SELECT idcapitolo,capitoli.idcapitolotipo AS tipo,capitoli.ordine AS cordine,capitolitipi.ordine AS tordine,isbullet 
									FROM capitoli 
									JOIN capitolitipi ON capitoli.idcapitolotipo=capitolitipi.idcapitolotipo 
									WHERE taginclude like '% " . $this->aPagina['tag'] . " %'", $this->dbro);
				while ($rd = mysql_fetch_array($qrd)) {
					$aCapitoli[] = str_pad($rd['tordine'], 8, ' ', STR_PAD_LEFT) . '|' . str_pad($rd['cordine'], 8, ' ', STR_PAD_LEFT). "|$rd[tipo]|$rd[idcapitolo]|$rd[isbullet]|1";
				}
				// vediamo se c'e' qualcosa da visualizzare
				if (count($aCapitoli) > 0) {
					asort($aCapitoli);
					$oldidtipo = 0;
					$oldbullet = 0;
					foreach ($aCapitoli as $xcap) {
						list($tordine, $cordine, $idtipo, $idcapitolo, $isbullet, $referenziato) = explode('|', $xcap);
						if ($oldidtipo != $idtipo) {
							if ($oldbullet == 1 and $oldidtipo != 0) $b.= "\n</ul>";
							$rrd = mysql_query("SELECT tag,intestazione FROM capitolitipi WHERE idcapitolotipo=$idtipo", $this->dbro);
							$rd = mysql_fetch_array($rrd);
							// titolo
							$b .= "\n<div class='testocapitolotitolo'>";
							// icona per il link a top
							$b .= "\n<span class='testocapitolotitololinktop'><a href='#top'>" . $this->costruisciURLImmagineSkin('icona-top.png', 'Top') . "></a></span>";
							if ('' != trim($rd['tag'])) $b.= "<a name='$rd[tag]'>";
							$b .= "<span class='testocapitolotitolotesto'>$rd[intestazione]</span>";
							if ('' != trim($rd['tag'])) $b.= "</a>";
							$b .= "\n</div>"; // chiuso testocapitolotitolo
							// riferimento ed eventuale UL
							$this->aggiungiRiferimento(' Su questa pagina', "<a href='#$rd[tag]'>$rd[intestazione]</a>");
							if (1 == $isbullet) $b.= "\n<ul class='capitolopunto'>";
						}
						$rrd = mysql_query("SELECT testo,idpagina FROM capitoli WHERE idcapitolo=$idcapitolo", $this->dbro);
						$rd = mysql_fetch_array($rrd);
						$testo = $rd['testo'];
						if (1 == $referenziato) {
							$rrrd = mysql_query("SELECT tag,titolondx FROM pagine WHERE idpagina=$rd[idpagina]", $this->dbro);
							$rrd = mysql_fetch_array($rrrd);
							$testo .= ' [{' . $rrd['titolondx'] . '|' . $rrd['tag'] .'}]';
						}
						if (1 == $isbullet) {
							$b .= "\n<li>" . $this->espandiLink($testo) . "</li>";
						} else {
							$b .= "\n<div class='testocapitolotesto'>" . $this->espandiLink($testo) . "</div>";
						}
						$oldidtipo = $idtipo;
						$oldbullet = $isbullet;
					}
					if (1 == $oldbullet) $b.= "\n</ul>";
				}			
				break;
			case 'tuttapagina':
				$qrd = mysql_query("SELECT ordine,testo FROM capitoli WHERE idpagina=" . $this->aPagina['idpagina'] . " ORDER BY ordine", $this->dbro);
				$b .= "\n<ul class='capitolopunto'>";
				while ($rd = mysql_fetch_array($qrd)){
					$b .= "\n<li>" . $this->espandiLink($rd['testo']) . "</li>";
				}	
				$b .= "\n</ul>";
				break;
		}
		$b .= "\n</div>"; //testocapitolo
		return $b;
	}


	/**
	 * aggiungiRiferimento($categoria, $riferimento)
	 * 
	 * Aggiunge un riferimento da mostrare nella colonna di destra
	 * 
	 * @param string $categoria categoria del riferimento (intestazione)
	 * @param string $riferimento riferimento da aggiungere
	 */
	function aggiungiRiferimento($categoria, $riferimento) {
		 array_push($this->aRifTitolo, $categoria) ;
		 array_push($this->aRifTesto, $riferimento) ;
	}


	/**
	 * scriviRiferimenti()
	 * 
	 * Aggiunge riferimenti se ne trova
	 * 
	 */
	function scriviRiferimenti() {
		$rif = '';
		//controlla se ci sono riferimenti e nel caso crea il relativo contenitore
		// aggiungo i riferimenti da database: link diretto
		if (!$this->iscronologia) {
			$qrd = mysql_query("SELECT categoria,riferimento
								FROM riferimenti 
								WHERE idpagina=" . $this->aPagina['idpagina'] . "
								ORDER BY categoria,riferimento", $this->dbro);
			while ($rd = mysql_fetch_array($qrd)) {
				$this->aggiungiRiferimento($rd['categoria'], $this->espandiLink($rd['riferimento']));
			}
		}
		// aggiungo i riferimenti da database: backlink standard
		$qrd = mysql_query("SELECT idpagina FROM riferimenti WHERE backlink='" . $this->aPagina['tag'] . "'", $this->dbro);
		// se trovo dei backlink, li elaboro
		while ($rd = mysql_fetch_array($qrd)) {
			$rd = mysql_query("SELECT tag,titolondx,riferimento 
								FROM pagine 
								JOIN sezioni ON pagine.idsezione=sezioni.idsezione 
								WHERE hidden=0 and idpagina=$rd[idpagina]", $this->dbro);
			$r = mysql_fetch_array($rd);
			$this->aggiungiRiferimento($r['riferimento'], $this->espandiLink('{' . $r['titolondx'] . '|' . $r['tag'] .'}'));
		}
		// faccio tutto il cinema solo se ci sono degli elementi da visualizzare
		if (count($this->aRifTesto) > 0) {
			array_multisort($this->aRifTitolo, $this->aRifTesto);
			$old = '***';
			$oldecho = '***';
			$buffer = '';
			$separatore = ' &bull; ';
			$datogliere = -8;
			for ($n = 0; $n < count($this->aRifTesto); $n++) {
				// rottura 
				if ($this->aRifTitolo[$n] != $old and '***' != $old) {
					$buffer = substr($buffer, 0, $datogliere);
					$rif .= "\n<div class='testoriferimento'><strong>$old</strong>: $buffer</div>";
					$buffer = '';
				}
				$old = $this->aRifTitolo[$n];
				$thisecho = $this->aRifTesto[$n] . $separatore;
				//output solamente se non sto riscrivendo la stessa cosa
				if ($thisecho !=$oldecho) {
					$buffer .= $thisecho;
				}
				$oldecho = $thisecho;
			}
			$buffer = substr($buffer, 0, $datogliere);
			$rif .= "\n<div class='testoriferimento'><strong>$old</strong>: $buffer</div>";
		}
		//genera il div per i riferimenti se c' qualcosa da mostrare
		if ('' != $rif) {
			$b = "\n<div class='riferimenti' align='right'>";
			$b .= $rif;
			$b .= "\n</div>"; //chiuso riferimenti
			return $b;
		}
	}


	/**
	 * pieDiPagina()
	 * 
	 * Scrive il pie` di pagina
	 * 
	 * @global array $tipopagina tipi di pagina
	 */
	function pieDiPagina() {
		global $tipopagina;
		$b = '';
		// scrivo la data solo se non e' la pagina delle statistiche
		$b .= "\n<tr><td class='piedipaginaultimoaggiornamento'>";
		if (($this->aPagina['tipo'] == $tipopagina['statistiche']) OR ($this->aPagina['tipo'] == $tipopagina['novita'])) {
			$b .= "Dati aggiornati in tempo reale.";
		} else {
			$b .= "\nUltima variazione della pagina: " . strftime('%A %d %B %Y, %H:%M:%S', $this->aPagina['lastmod']);
			if ('main' == $this->aPagina['tag']) {
				$mmr = mysql_query("SELECT lastmod FROM pagine ORDER BY lastmod DESC LIMIT 1", $this->dbro);
				$mr = mysql_fetch_array($mmr);
				$b .= "<br>\nUltimo aggiornamento del sito: " . strftime('%A %d %B %Y, %H:%M:%S', $mr[0]);
			}
		}
		$b .= "\n</td></tr>"; //chiuso piedipaginaultimoaggiornamento
		//motd
		$b .= "\n<tr><td class='mastermotd'>";
		if ($this->motd != '') $b .= $this->espandiLink($this->motd);
		if (file_exists('motd.txt')) {
			$b .= '<br>' . $this->espandiLink(file_get_contents('motd.txt'));
		}
		$b .= "</td></tr>"; //chiuso mastermotd
		// esponiamo le medagliette
		// serve una tabella per evitare di giocare con il colspan
		$b .= "\n<tr><td><table border='0' width='100%' class='piedipaginamedagliette'><tbody>";
		$b .= "\n<tr><td class='htmlvalidated'><!-- HTML 4.01 ok-->" . $this->espandiLink('{' . $this->costruisciURLimmagineSkin('vhtml401.png', 'Valid HTML 4.01 Transitional') . '>|@http://validator.w3.org/check?uri=referer}') . '</td>';
		$b .= "\n<td class='cssvalidated'><!-- css ok-->" . $this->espandiLink('{' . $this->costruisciURLimmagineSkin('vcss.png', 'Valid CSS!') . '>|@http://jigsaw.w3.org/css-validator/}') . '</td>';
		$b .= "\n<td class='xajaxpowered'>" . $this->espandiLink('{' . $this->costruisciURLimmagineSkin('xajax_powered.png', 'Powered by xajax') . '>|@http://www.xajax-project.org/}') . '</td>';
		$b .= "</tr></tbody></table></td></tr>";
		// copyleft
		$b .= "<tr><td class='gnufdl'>Tutti i testi sono disponibili nel rispetto dei termini della " . $this->espandiLink('{GNU Free Documentation License | @http://www.gnu.org/copyleft/fdl.html}.') . '</td></tr>';
		return $b;
	}


	/**
	 * espandiLink($testo)
	 * 
	 * Analizza il testo in input e lo restituisce in output dopo aver espanso le sequenze tra parentesi graffe:
	 * { testo | tag } link a pagina
	 * { testo | ^url } link interno
	 * { testo | @url } link esterno
	 * { testo | url } link hyperalliance
	 * { testo | :tag } link a indice
	 * { descrizione | >tag[+tag] } immagine nel testo allineata a destra con classe opportuna, opzionalmente thumbnail con link a _blank e descrizione
	 * { align[+descrizione] | *tag[+tag] } immagine nel testo, opzionalmente thumbnail con link a _blank e descrizione
	 * { align[+descrizione] | #tag } immagine nel testo con rotazione a seconda della data
	 * { testo | %ntag } tabella, il testo viene incluso nel tag <TABLE>, n indica se e' una tabella a 2 o a 3 colonne
	 * { align | !tag } esegue una 'macro'
	 * { descrizione | $fileimmagine } immagine da skin
	 * 
	 * @param string $testo testo da analizzare
	 * @todo gestire link a oggetti non html/img all'interno del sito
	 */
	function espandiLink($testo) {
		preg_match_all( "!(\{[^\{]+\})!i" , $testo , $aMatch );
		for ($i = 0; $i < count ($aMatch[1]); $i++) {
			//toglie le parentesi graffe
			$sanitized = preg_replace("!(\{|\})!" , "" , $aMatch[1][$i]);
			// explode e' piu' veloce
			list ($hot, $tag) = explode('|' , $sanitized);
			$hot = trim($hot);
			$tag = trim($tag);
			// ho esploso la stringa, ora mi comporto di conseguenza
			// immagine allineata a destra nel testo
			if ('>' == substr($tag, 0, 1)) {
				// eventuale descrizione forzata
				$descforzata = $hot;
				$imgtag = substr($tag, 1);
				// verifico se dopo il pipe c'e' la specificazione di un thumbnail (tag1+tag2)
				if (($piu = strpos($tag, '+')) === false) {
					$rd = mysql_query("SELECT idimmagine FROM immagini WHERE imgtag='$imgtag'", $this->dbro);
					$r = mysql_fetch_array($rd);
					$newb = $this->costruisciURLimmagine($r['idimmagine'], $descforzata) . " align='right' class='allineatadestra'>";
				} else {
					$aImgTag = explode('+', $imgtag);
					// link all'immagine intera
					$rd = mysql_query("SELECT idimmagine FROM immagini WHERE imgtag='$imgtag'", $this->dbro);
					$r = mysql_fetch_array($rd);
					$newb = "<a target='_blank' href='" . $this->aSetup['docroot'] . $this->aSetup['pathimmagini'] . $r[0] . "' title=\"Click per vedere l'immagine intera\">";
					//thumbnail
					$rd = mysql_query("SELECT idimmagine FROM immagini WHERE imgtag='$aImgTag[0]'", $this->dbro);
					$r = mysql_fetch_array($rd);
					$newb .= $this->costruisciURLimmagine($r['idimmagine']) . " class='allineatadestra'></a>";
				}
			}
			// immagine
			elseif ('*' == substr($tag, 0, 1)) {
				$descforzata='';
				$newhot = $hot;
				// verifico se la prima parte include l'indicazione della descrizione
				if (!(strpos($newhot, '+') === false)) {
					$aHot = explode('+', $newhot);
					$newhot = trim($aHot[0]);
					$descforzata = trim($aHot[1]);
				}
				$imgtag = substr($tag, 1);
				// verifico se dopo il pipe c'e' la specificazione di un thumbnail (tag1+tag2)
				if (($piu = strpos($tag, '+')) === false) {
					$rd = mysql_query("SELECT idimmagine FROM immagini WHERE imgtag='$imgtag'", $this->dbro);
					$r = mysql_fetch_array($rd);
					$newb = $this->costruisciURLimmagine($r['idimmagine'], $descforzata);
					if ('' != $newhot) $newb .= " align='$newhot'";
					$newb .= '>';
				} else {
					$aImgTag = explode('+', $imgtag);
					// link all'immagine intera
					$rd = mysql_query("SELECT file FROM immagini WHERE imgtag='$aImgTag[1]'", $this->dbro);
					$r = mysql_fetch_array($rd);
					$newb = "<a target='_blank' href='" . $this->aSetup['docroot'] . $this->aSetup['pathimmagini'] . $r[0] . "' title=\"Click per vedere l'immagine intera\">";
					//thumbnail
					$rd = mysql_query("SELECT idimmagine FROM immagini WHERE imgtag='$aImgTag[0]'", $this->dbro);
					$r = mysql_fetch_array($rd);
					$newb .= $this->costruisciURLimmagine($r['idimmagine']);
					if ('' != $newhot) $newb .= " align='$newhot'";
					$newb .= '></a>';
				}
			// immagine che cambia con la data o a caso
			} elseif ('#' == substr($tag, 0, 1)) {
				$descforzata='';
				$newhot = $hot;
				// verifico se la prima parte include l'indicazione della descrizione
				if (!(strpos($newhot, '+') === false)) {
					$aHot = explode('+', $newhot);
					$newhot = trim($aHot[0]);
					$descforzata = trim($aHot[1]);
				}
				$imgtag = substr($tag, 1);
				// vedo se il tag si riferisce ad un'immagine random
				$rcas = mysql_query("SELECT mesegiorno FROM immaginidata WHERE tag='$imgtag' AND mesegiorno='rand'", $this->dbro);
				if (mysql_num_rows($rcas) > 0) {
					// immagine casuale
					$quale = rand(1, mysql_num_rows($rcas));
					$qcas = mysql_query("SELECT idimmagine FROM immaginidata WHERE tag='$imgtag'", $this->dbro);
					for ($conta = 1; $conta <= $quale; $conta++) {
						$rcas = mysql_fetch_array($qcas);
					}
					$newb = $this->costruisciURLimmagine($rcas['idimmagine'], $descforzata);
					if ('' != $newhot) $newb .= " align='$newhot'";
					$newb .= '>';
				} else {
					// immagine basata sulla data
					$oggi = date("m-d");
					$r = mysql_query("SELECT idimmagine FROM immaginidata WHERE mesegiorno='$oggi' AND tag='$imgtag'", $this->dbro);
					if (mysql_num_rows($r) > 0) {
						$rw = mysql_fetch_array($r);
						$newb = $this->costruisciURLimmagine($rw['idimmagine'], $descforzata);
						if ('' != $newhot) $newb .= " align='$newhot'";
						$newb .= '>';
					} else {
						$q = mysql_query("SELECT idimmagine FROM immaginidata WHERE mesegiorno='*' AND tag='$imgtag'", $this->dbro);
						$r = mysql_fetch_array($q);
						$newb = $this->costruisciURLimmagine($r['idimmagine'], $descforzata);
						if ('' != $newhot) $newb .= " align='$newhot'";
						$newb .= '>';
					}
				}
			// immagine da skin
			} elseif ('$' == substr($tag, 0, 1)) {
				$newb = $this->costruisciURLimmagineskin(substr($tag, 1), $hot) . '>';
			// 'macro'
			} elseif ('!' == substr($tag, 0, 1)) {
				$macrotag = substr($tag, 1);
				$newb = $this->eseguiMacro($macrotag);
			// link interno
			} elseif ('^' == substr($tag, 0, 1)) {
				$url = substr($tag, 1);
				$newb = "<a target='_top' href='" . $this->aSetup['docroot'] . $url . "'>";
				$newb .= $hot . "</a>";
			// link esterno
			} elseif ('@' == substr($tag, 0, 1)) {
				$url = substr($tag, 1);
				$newb = "<a target='_blank' title='Link esterno a HyperB5' class='esterno' href='$url'>";
				$newb .= $hot . "</a>";
			// link hyperalliance
			} elseif ('' == substr($tag, 0, 1)) {
				$url = substr($tag, 1);
				$newb = "<a target='_blank' title='Link a sito della HyperAlliance' class='hyperall' href='$url'>";
				$newb .= $hot . "</a>";
			// tabella
			} elseif ('%' == substr($tag, 0, 1)) {
				$colonne = substr($tag, 1, 1);
				$tabtag = substr($tag, 2);
				$addtag = $hot;
				$qr = mysql_query("SELECT * FROM tabelle WHERE ttag='$tabtag' ORDER BY tordine", $this->dbro);
				$newb = "\n<table $addtag>";
				while ($r = mysql_fetch_array($qr)) {
					// riassegno le variabili per evitare un comportamento di 
					// Internet Explorer in merito alle celle vuote
					if ('' != trim($r['prima'])) $prima = $r['prima']; else $prima = '&nbsp;';
					if ('' != trim($r['seconda'])) $seconda = $r['seconda']; else $seconda = '&nbsp;';
					if ('' != trim($r['terza'])) $terza = $r['terza']; else $terza = '&nbsp;';
					if ('' != trim($r['quarta'])) $quarta = $r['quarta']; else $quarta = '&nbsp;';
					$newb .= "\n<tr>";
					if (1 == $r['istitolo']) {
						$newb .= "\n<td colspan='$colonne' class='titolo'>";
						$newb .= $this->espandiLink($prima);
						$newb .= "\n</td>";
					} else {
						// 1
						if (strpos($r['qualicenter'], '1') === false ) {
							$newb .= "\n<td>";
						} else {
							$newb .= "\n<td>";
						}
						$newb .= $this->espandiLink($prima);
						$newb .= "</td>";
						// 2
						if (strpos($r['qualicenter'], '2') === false ) {
							$newb .= "\n<td>";
						} else {
							$newb .= "\n<td>";
						}
						$newb .= $this->espandiLink($seconda);
						$newb .= "</td>";
						if ($colonne >= 3) {
							// 3
							if (strpos($r['qualicenter'], '3') === false ) {
								$newb .= "\n<td>";
							} else {
								$newb .= "\n<td>";
							}
							$newb .= $this->espandiLink($terza);
							$newb .= "</td>";
						}
						if ($colonne >= 4) {
							// 4
							if (strpos($r['qualicenter'], '4') === false ) {
								$newb .= "\n<td>";
							} else {
								$newb .= "\n<td>";
							}
							$newb .= $this->espandiLink($quarta);
							$newb .= "</td>";
						}
					}
					$newb .= "\n</tr>";
				}
				$newb .= "\n</table>";
			// indice
			} elseif (':' == substr($tag, 0, 1)) {
				$idindice = 0;
				$tagindice = substr($tag, 1);
				$q = mysql_query("SELECT idsezione FROM sezioni WHERE indextag='$tagindice'", $this->dbro);
				if (mysql_num_rows($q) > 0) {
					$r = mysql_fetch_array($q);
					$idindice = $r['idsezione'];
				}
				$newb = "<a href='" . $this->costruisciURL($this->aPagina['tag'], '') . "' target='_top' onClick='xajax_AJAXscriviIndice($idindice); return false' >$hot</a>";
			//tag normale
			} else {
				if (($anchorpos = strpos($tag, '#')) > 0) {
					$anchor = trim(substr($tag, $anchorpos + 1));
					$tag = trim(substr($tag, 0, $anchorpos));
				} else {
					$anchor ='';
				}
				// se il link punta a me stesso, lo tolgo
				if ($tag == $this->aPagina['tag'] and '' == $anchor) {
					$newb = $hot;
				} else {
					$newb = "<a href='" . $this->costruisciURL($tag, $anchor) . "' target='_top'>$hot</a>";
				}
			}
			$testo = str_replace( $aMatch[1][$i] , $newb, $testo);
		}
		return $testo;
	}


	/**
	 * apparizioniCast()
	 * 
	 * Genera la tabella con l'elenco delle apparizioni di un attore
	 * 
	 */
	function apparizioniCast() {
		$b = '';
		// chiavedisort ~ ruolo ~ episodio
		$apparizioni = array();
		// faccio passare i ruoli come regia, autore della storia...
		// tutto 'sto cinema di select per cavare tre campi
		$qrd = mysql_query("SELECT DISTINCT p1.titolondx as titolondx,descrizione,valore,p1.tag as tag, p2.titolondx as ctitolondx 
							FROM episodivalori
							JOIN pagine as p1 ON episodivalori.idpagina=p1.idpagina
							JOIN pagine as p2 ON episodivalori.idpaginacast=p2.idpagina
							JOIN episodicampi on episodivalori.idcampo=episodicampi.idcampo
							JOIN listaepisodi ON episodivalori.idpagina=listaepisodi.idpagina
							JOIN sezioni ON p1.idsezione=sezioni.idsezione
							WHERE episodivalori.idpaginacast=" . $this->aPagina['idpagina'] . " 
							ORDER BY serie, descrizione, ordinetrasmissione", $this->dbro);
		while ($rd = mysql_fetch_array($qrd)) {
			//gestisco la possibilit che l'attore abbia il credit con un nome diverso da quello nella sua scheda
			if ($rd['ctitolondx'] == strip_tags($rd['valore'])) {
				array_push($apparizioni, $rd['descrizione'] . '~' . $rd['descrizione'] . '~{' . $rd['titolondx'] . '|' . $rd['tag'] . '}');
			} else {
				array_push($apparizioni, $rd['descrizione'] . '~' . $rd['descrizione'] . '~{' . $rd['titolondx'] . '|' . $rd['tag'] . '} (come ' . strip_tags($rd['valore']) . ')');
			}
		}
		// faccio passare i ruoli come attore 
		// altro cinema di select per cavare tre campi
		$qrd = mysql_query("SELECT DISTINCT personaggio,nomeattore,uncredited,creditonly,p1.tag as tag,p1.titolondx as titolondx,
							p2.tag as ptag,p2.titolondx as ptitolondx,p2.chiavesort AS chiavesort
							FROM guest
							JOIN pagine as p1 ON guest.idpagina=p1.idpagina
							LEFT JOIN pagine as p2 ON guest.idpaginapersonaggio=p2.idpagina
							JOIN listaepisodi ON guest.idpagina=listaepisodi.idpagina
							JOIN sezioni ON p1.idsezione=sezioni.idsezione
							WHERE guest.idpaginacast=" . $this->aPagina['idpagina'] . "
							ORDER BY serie, personaggio, ordinetrasmissione", $this->dbro);
		while ($rd = mysql_fetch_array($qrd)) {
			$c = '';
			$n = '';
			// gestisco la possibilit che l'attore abbia il credit con un nome diverso da quello nella sua scheda o non abbia il credit o non compaia pur avendo il credit
			if ('1' == $rd['uncredited']) {
				$c = " (senza credit)";
			}
			if ('1' == $rd['creditonly']) {
				$c = " (solo credit)";
			}
			if ('' != $rd['nomeattore']) {
				$n = " (come $rd[nomeattore])";
			}
			$z = '~{' . $rd['titolondx'] . '|' . $rd['tag'] . '}' . $c . $n;
			// personaggio
			if ('' == trim($rd['personaggio'])) {
				// nome di default
				$zz = $rd['chiavesort'] . '~{' . $rd['ptitolondx'] . '|' . $rd['ptag'] . '}' . $z;
			} else {
				if ('' == trim($rd['ptag'])) {
					// personaggio generico
					$zz = $rd['personaggio'] . '~' .$rd['personaggio'] . $z;
				} else {
					// personaggio con descrizione alternativa, decido se devo espandere il nome con il meta '@@@'
					if (strpos($rd['personaggio'], '@@@') === FALSE) {
						$zz = $rd['personaggio'] . '~{' . $rd['personaggio'] . '|' . $rd['ptag'] . '}' . $z;
					} else {
/*						$zzzz = '{' . $rd['ptitolondx'] . '|' . $rd['ptag'] . '}';
						$personaggio = str_replace('@@@', $zzzz, $rd['personaggio']);
						$zz = $rd['chiavesort'] . '~{' . $rd['ptitolondx'] . '|' . $rd['ptag'] . '}' . $z . " ($personaggio)";
*/						$personaggio = str_replace('@@@', $rd['ptitolondx'], $rd['personaggio']);
						$zz = $rd['chiavesort'] . '~{' . $personaggio . '|' . $rd['ptag'] . '}' . $z;
					}
				}
			}	
			array_push($apparizioni,$zz);
		}
		// faccio passare i ruoli come autore, disegnatore... esclusi quelli
		// come autore della storia (idcampo=12) o regista (idcampo=13) 
		// il metodo non  il massimo dello stile, ma  rapido
		$qrd = mysql_query("SELECT p1.titolondx as titolondx,descrizione,valore,p1.tag as tag, p2.titolondx as ctitolondx 
					FROM episodivalori
					JOIN pagine as p1 ON episodivalori.idpagina=p1.idpagina
					JOIN pagine as p2 ON episodivalori.idpaginacast=p2.idpagina
					JOIN episodicampi on episodivalori.idcampo=episodicampi.idcampo
					WHERE episodivalori.idcampo <> 12 AND episodivalori.idcampo <> 13 AND episodivalori.idpaginacast=" . $this->aPagina['idpagina'], $this->dbro);
		while ($rd = mysql_fetch_array($qrd)) {
			//gestisco la possibilit che l'attore abbia il credit con un nome diverso da quello nella sua scheda
			if ($rd['ctitolondx'] == strip_tags($rd['valore'])) {
				array_push($apparizioni, $rd['descrizione'] . '~' . $rd['descrizione'] . '~{' . $rd['titolondx'] . '|' . $rd['tag'] . '}');
			} else {
				array_push($apparizioni, $rd['descrizione'] . '~' . $rd['descrizione'] . '~{' . $rd['titolondx'] . '|' . $rd['tag'] . '} (come ' . $rd['ctitolondx'] . ')');
			}
		}
/*		//apparizioni in un'intera serie NUOVO METODO
		$qrf = mysql_query("SELECT DISTINCT idcast,idpersonaggio,linkserie,tag,titolondx,chiavesort 
		                           FROM castfisso 
		                           JOIN pagine ON castfisso.idpersonaggio=pagine.idpagina
		                           WHERE idcast=" . $this->aPagina['idpagina'], $this->dbro);
		while ($rf = mysql_fetch_array($qrf)) {
			array_push($apparizioni, $rf['chiavesort'] . '~{' . $rf['titolondx'] . '|' . $rf['tag'] . '}~' . $rf['linkserie']);
		}
		//apparizioni in un'intera serie (prende i dati solo se esiste la pagina del personaggio!!!) VECCHIO METODO
		$qrd = mysql_query("SELECT personaggio,p1.tag as tag,p1.titolondx as titolondx,
							p2.tag as ptag,p2.titolondx as ptitolondx,p2.chiavesort AS chiavesort
							FROM castfisso
							JOIN pagine as p1 ON castfisso.idpagina=p1.idpagina
							LEFT JOIN pagine as p2 ON castfisso.idpaginapersonaggio=p2.idpagina
							JOIN listaepisodi ON castfisso.idpagina=listaepisodi.idpagina
							JOIN sezioni ON p1.idsezione=sezioni.idsezione
							WHERE castfisso.idpaginacast=" . $this->aPagina['idpagina'] . " 
							ORDER BY serie, ordinetrasmissione", $this->dbro);
		while ($rd = mysql_fetch_array($qrd)) {
			$z = '~{' . $rd['titolondx'] . '|' . $rd['tag'] . '}';
			if ('' == trim($rd['personaggio'])) {
				// nome di default
				$zz = $rd['chiavesort'] . '~{' . $rd['ptitolondx'] . '|' . $rd['ptag'] . '}' . $z;
			} else {
				if ('' == trim($rd['ptag'])) {
					// personaggio generico
					$zz = $rd['personaggio'] . '~' . $rd['personaggio'] . $z;
				} else {
					// personaggio con descrizione alternativa, decido se devo espandere il nome con il meta '@@@'
					if (strpos($rd['personaggio'], '@@@') === FALSE) {
						$zz = $rd['personaggio'] . '~{' . $rd['personaggio'] . '|' . $rd['ptag'] . '}' . $z;
					} else {
						$zzzz = '{' . $rd['ptitolondx'] . '|' . $rd['ptag'] . '}';
						$personaggio = str_replace('@@@', $zzzz, $rd['personaggio']);
//						$zz = $rd['chiavesort'] . '~{' . $rd['ptitolondx'] . '|' . $rd['ptag'] . '}' . $z . " ($personaggio)";
						$zz = $rd['chiavesort'] . '~' . $personaggio . $z;
					}
				}
			}
			array_push($apparizioni,$zz);
		} */
		// una volta popolato l'array, lo visualizzo (se non  vuoto)
		if (0 < count($apparizioni)) {
//			sort($apparizioni);
			$old = '***';
			$buf = '';
			foreach ($apparizioni as $k => $a) {
				list ($scarta, $ruolo, $episodio) = explode('~', $a);
				if ($ruolo != $old) {
					if ('***' != $old) {
						$buf = substr($buf, 0, -7);
						$buf .= ".</div>\n";
					}
					$buf.= "<div class='apparizionicast'><strong>" . $this->espandiLink($ruolo) . '</strong>:';
				}
				$old = $ruolo;
				$buf .= ' ' . $this->espandiLink($episodio) . ' &bull;';
			}
			$buf = substr($buf, 0, -7);
			$buf .= ".</div>\n";
			$b .= $buf;
			return $b;
		}
	}


	/**
	 * calcolaApparizioniPersonaggio()
	 * 
	 * Calcola le apparizioni di un personaggio e popola i riferimenti 
	 * 
	 */
	function calcolaApparizioniPersonaggio() {
		$qrd = mysql_query("SELECT p1.tag AS tag,p1.titolondx AS titolondx, riferimento 
							FROM guest
							JOIN pagine AS p1 ON guest.idpagina=p1.idpagina
							JOIN sezioni ON p1.idsezione = sezioni.idsezione
							WHERE guest.idpaginapersonaggio=" . $this->aPagina['idpagina'] . " AND uncredited='0' AND iscastfisso='0' 
							ORDER BY titolondx", $this->dbro);
		while ($rd = mysql_fetch_array($qrd)) {
			$this->aggiungiRiferimento($rd['riferimento'], $this->espandiLink('{' . $rd['titolondx'] . '|' . $rd['tag'] . '}'));
		}	
		//eventuali apparizioni nel cast fisso
		$qrf = mysql_query("SELECT DISTINCT idpersonaggio,linkserie 
		                           FROM castfisso 
		                           WHERE idpersonaggio=" . $this->aPagina['idpagina'], $this->dbro);
		while ($rf = mysql_fetch_array($qrf)) {
			$this->aggiungiRiferimento('Serie', $this->espandiLink($rf['linkserie']));
		}
/*		//eventuali apparizioni nel cast fisso
		$qrf = mysql_query("SELECT DISTINCT idpaginapersonaggio,linkserie 
							FROM castfisso 
							WHERE idpaginapersonaggio=" . $this->aPagina['idpagina'] . " AND linkserie<>''", $this->dbro);
		while ($rf = mysql_fetch_array($qrf)) {
			$this->aggiungiRiferimento('Serie', $this->espandiLink($rf['linkserie']));
		} */
	}


	/**
	 * calcolaAttoriPersonaggio()
	 * 
	 * Calcola gli attori che hanno interpretato quel personaggio
	 * 
	 */
	function calcolaAttoriPersonaggio() {
		$qrd = mysql_query("SELECT DISTINCT idpaginapersonaggio,idpaginacast,titolondx,tag 
							FROM guest
							JOIN pagine ON guest.idpaginacast=pagine.idpagina
							WHERE guest.idpaginapersonaggio=" . $this->aPagina['idpagina'], $this->dbro);
		while ($rd = mysql_fetch_array($qrd)) {
			$this->aggiungiRiferimento('Interpreti', $this->espandiLink('{' . $rd['titolondx'] . '|' . $rd['tag'] . '}'));
		}
		//eventuali apparizioni nel cast fisso
		$qrf = mysql_query("SELECT DISTINCT idcast,idpersonaggio,linkserie,tag,titolondx 
		                           FROM castfisso 
		                           JOIN pagine ON castfisso.idcast=pagine.idpagina 
		                           WHERE idpersonaggio=" . $this->aPagina['idpagina'], $this->dbro);
		while ($rf = mysql_fetch_array($qrf)) {
			$this->aggiungiRiferimento('Interpreti', $this->espandiLink('{' . $rf['titolondx'] . '|' . $rf['tag'] . '}'));
		}
/*		//eventuali apparizioni nel cast fisso VECCHIO METODO
		$qrf = mysql_query("SELECT DISTINCT idpaginacast,idpaginapersonaggio,linkserie,tag,titolondx 
							FROM castfisso 
							JOIN pagine ON castfisso.idpaginacast=pagine.idpagina 
							WHERE idpaginapersonaggio=" . $this->aPagina['idpagina'] . " AND linkserie<>''", $this->dbro);
		while ($rf = mysql_fetch_array($qrf)) {
			$this->aggiungiRiferimento('Interpreti', $this->espandiLink('{' . $rf['titolondx'] . '|' . $rf['tag'] . '}'));
		} */
	}


	/**
	 * costruisciURL($tag, $anc)
	 * 
	 * Costruisce l'url completo in base al tag
	 * 
	 * @param string $tag tag della pagina target
	 * @param string $anc eventuale anchor
	 */
	function costruisciURL($tag, $anc = '') {
		$b = $this->aSetup['docroot'] . 'index.php/' . $tag;
		if ('' != $anc) {
			$b .= "#$anc";
		} 
		return $b;
	}
	

	/**
	 * costruisciURLimmagine($img, $dsc)
	 * 
	 * Costruisce l'url completo di un'immagine.<br>
	 * Se il primo parametro e' numerico lo tratta come l'ID dell'immagine da mostrare
	 *
	 * @param mixed $img tag o ID dell'immagine da mostrare
	 * @param string $dsc descrizione dell'immagine
	 */
	function costruisciURLimmagine($img, $dsc='') {
		$b = "<img src='" . $this->aSetup['docroot'];
		// se $img e' numerico lo considero l'ID dell'immagine da mostrare e becco tutti i dati dalla tabella
		if (is_numeric($img)) {
			$rd = mysql_query("SELECT * FROM immagini WHERE idimmagine=$img", $this->dbro);
			$r = mysql_fetch_array($rd);
			if (substr($r['file'], 0, 1) == '/') {
				$b .= substr($r['file'], 1);
			} else {
				$b .= $this->aSetup['pathimmagini'] . $r['file'];
			}
			// se non c'e' l'override della descrizione
			if ('' == $dsc) {
				$dsc = $r['descrizione'];
			} 
			$dsc = strip_tags($dsc);
			$dsc = str_replace("'", "&#39;", $dsc);
			$dsc = $this->stripLink($dsc);
			$b .= "' border='0' alt='$dsc' title='$dsc'";
			$b .= " width='$r[larghezza]' height='$r[altezza]'";
		} else {
			// se $img inizia con un '/' significa che non considero la dir del path
			// ma e' un path assoluto all'interno del sito
			if (substr($img, 0, 1) == '/') {
				$b .= substr($img, 1);
			} else {
				$b .= $this->aSetup['pathimmagini'] . $img;
			}
			$dsc = strip_tags($dsc);
			$dsc = str_replace("'", "&#39;", $dsc);
			$dsc = $this->stripLink($dsc);
 			$b .= "' border='0' alt='$dsc' title='$dsc'";
		}
		return $b;
	}


	/**
	 * costruisciURLimmagineskin($img, $dsc)
	 * 
	 * Costruisce l'url completo di un'immagine della skin.<br>
	 *
	 * @param string $img file dell'immagine da mostrare
	 * @param string $dsc descrizione dell'immagine
	 */
	function costruisciURLimmagineskin($img, $dsc='') {
		$imgpath = $this->skin . $img;
		$dsc = strip_tags($dsc);
		$dsc = str_replace("'", "&#39;", $dsc);
		$dsc = $this->stripLink($dsc);
		// metto il punto davanti senno' mi va a prendere l'immagine nella root del file system
		$a = getimagesize('.' . $imgpath);
		$b = "<img border='0' src='$imgpath' alt='$dsc' title='$dsc' $a[3]";
		return $b;
	}


	/**
	 * calcolaClasseNave()
	 * 
	 * Calcola qual e' la classe dell'astronave che stiamo visualizzando
	 *
	 */
	function calcolaClasseNave() {
/*		// non lo eseguo per le asetronavi varie
		if ($this->aPagina['idsezione'] != 46) { */
			$rif = $this->espandiLink('{' .  $this->aSezione['sigla'] . '|:' . $this->aSezione['indextag'] . '}');
			$this->aggiungiRiferimento('Navi', $rif);
//		}
	}


	/**
	 * statisticheDelSito()
	 * 
	 * Scrive le statistiche del sito
	 *
	 */
	function statisticheDelSito() {
		// software
		$b .= "\n<div class='statistichetitolo'>Software di visualizzazione</div>";
		$b .= "\n<div class='statistiche'>Versione del software: " . $this->aSetup['versione'] . "</div>";
		$b .= "\n<div class='statistiche'>Ultimo aggiornamento del motore di visualizzazione: " . strftime('%A %d %B %Y, %H:%M:%S', filemtime('include/output.php')) . "</div>";
		// pagine 
		$b .= "\n<div class='statistichetitolo'>Pagine</div>";
		$rd = mysql_query("SELECT COUNT(idpagina) FROM pagine", $this->dbro);
		$r = mysql_fetch_array($rd);
		$hmpagine = $r[0];
		$b .= "\n<div class='statistiche'>Pagine totali: $hmpagine</div>";
		$rd = mysql_query("SELECT lastmod,tag,titolo FROM pagine WHERE hidden=0 AND tag <> 'novita' ORDER BY lastmod LIMIT 1", $this->dbro);
		$r = mysql_fetch_array($rd);
		if ('main' == $r['tag']) {
			$b .= "\n<div class='statistiche'>Pagina pi&ugrave; vecchia: " . $this->espandiLink('{' . $r['titolo'] . '|copertina}' ) . ' aggiornata ' . strftime('%A %d %B %Y, %H:%M:%S', $r['lastmod']) . '</div>';
		} else {
			$b .= "\n<div class='statistiche'>Pagina pi&ugrave; vecchia: " . $this->espandiLink('{' . $r['titolo'] . '|' . $r['tag'] . '}' ) . ' aggiornata ' . strftime('%A %d %B %Y, %H:%M:%S', $r['lastmod']) . '</div>';
		}
		$rd = mysql_query("SELECT lastmod,tag,titolo FROM pagine WHERE hidden=0 AND tag <> 'novita' ORDER BY lastmod DESC LIMIT 1", $this->dbro);
		$r = mysql_fetch_array($rd);
		if ('main' == $r['tag']) {
			$b .= "\n<div class='statistiche'>Ultima pagina aggiornata: " . $this->espandiLink('{' . $r['titolo'] . '|copertina}' ) . ' aggiornata ' . strftime('%A %d %B %Y, %H:%M:%S', $r['lastmod']) . '</div>';		
		} else {
			$b .= "\n<div class='statistiche'>Ultima pagina aggiornata: " . $this->espandiLink('{' . $r['titolo'] . '|' . $r['tag'] . '}' ) . ' aggiornata ' . strftime('%A %d %B %Y, %H:%M:%S', $r['lastmod']) . '</div>';
		}
		$rd = mysql_query("SELECT lastmod,tag,titolo FROM pagine WHERE hidden=0 AND tag <> 'novita' ORDER BY idpagina DESC LIMIT 1", $this->dbro);
		$r = mysql_fetch_array($rd);
		if ('main' == $r['tag']) {
			$b .= "\n<div class='statistiche'>Ultima pagina aggiunta: " . $this->espandiLink('{' . $r['titolo'] . '|copertina}' ) . ' aggiornata ' . strftime('%A %d %B %Y, %H:%M:%S', $r['lastmod']) . '</div>';
		} else {
			$b .= "\n<div class='statistiche'>Ultima pagina aggiunta: " . $this->espandiLink('{' . $r['titolo'] . '|' . $r['tag'] . '}' ) . ' aggiornata ' . strftime('%A %d %B %Y, %H:%M:%S', $r['lastmod']) . '</div>';
		}
		// elementi delle pagine
		$b .= "\n<div class='statistichetitolo'>Elementi delle pagine</div>";
		$rd = mysql_query("SELECT COUNT(idtesto) FROM testi", $this->dbro);
		$r = mysql_fetch_array($rd);
		$b .= "\n<div class='statistiche'>Paragrafi di testo generici: $r[0]</div>";
		$rd = mysql_query("SELECT COUNT(idcapitolo) FROM capitoli", $this->dbro);
		$r = mysql_fetch_array($rd);
		$b .= "\n<div class='statistiche'>Paragrafi all'interno dei capitoli: $r[0], di cui:<ul class='statistichepunto'>";
		$q = mysql_query("SELECT intestazione,COUNT(idcapitolo) FROM capitoli JOIN capitolitipi ON capitoli.idcapitolotipo=capitolitipi.idcapitolotipo GROUP BY capitolitipi.idcapitolotipo", $this->dbro);
		while ($r = mysql_fetch_array($q)) {
			$b .= "<li>$r[0]: $r[1]</li>";
		}
		$b.="</ul></div>";
		$rd = mysql_query("SELECT COUNT(idimmagine) FROM immagini", $this->dbro);
		$r = mysql_fetch_array($rd);
		$b .= "\n<div class='statistiche'>Immagini (escluse quelle utilizzate per le skin): $r[0]</div>";
		$rd = mysql_query("SELECT COUNT(idriferimento) FROM riferimenti", $this->dbro);
		$r = mysql_fetch_array($rd);
		$riferimenti = $r[0];
		$rd = mysql_query("SELECT COUNT(idriferimento) FROM riferimenti WHERE backlink<>''", $this->dbro);
		$r = mysql_fetch_array($rd);
		$riferimenti = $riferimenti + $r[0];
		$b .= "\n<div class='statistiche'>Riferimenti: $riferimenti</div>";
		$rd = mysql_query("SELECT COUNT(idvalore) FROM episodivalori", $this->dbro);
		$r = mysql_fetch_array($rd);
		$b .= "\n<div class='statistiche'>Valori delle tabelle degli episodi, dei libri e dei pianeti: $r[0]</div>";
		$rd = mysql_query("SELECT COUNT(idguest) FROM guest WHERE iscastfisso='0'", $this->dbro);
		$r = mysql_fetch_array($rd);
		$b .= "\n<div class='statistiche'>Apparizioni delle guest star: $r[0]</div>";
/*		// Statistiche giornaliere
		$b .= "\n<div class='statistichetitolo'>Statistiche giornaliere aggiornate il " . $this->readSetup('stat_update') . "</div>";
		$b .= "\n<div class='statistiche'>Link standard: " . $this->readSetup('stat_linkstd') . "</div>";
		$b .= "\n<div class='statistiche'>Link a indice: " . $this->readSetup('stat_linkndx') . "</div>";
		$rd = mysql_query("SELECT COUNT(imdb) FROM pagine WHERE imdb<>'' AND !ISNULL(imdb)", $this->dbro);
		$r = mysql_fetch_array($rd);
		$imdb = $r[0];
		$tot = $imdb + $this->readSetup('stat_linkext');
		$b .= "\n<div class='statistiche'>Link esterni: $tot</div>";
		$b .= "\n<div class='statistiche'>Macro: " . $this->readSetup('stat_linkmac') . "</div>"; */
		return $b;
	}


	/**
	 * aggiornaStatistiche($idp)
	 * 
	 * Aggiorna le statistiche di accesso
	 *
	 * @param integer $idp ID della pagina da conteggiare
	 */
	function aggiornaStatistiche($idp) {
		$q = mysql_query("SELECT accessi FROM contapagine WHERE idpagina=$idp", $this->dbrw);
		if (mysql_num_rows($q) > 0 ) {
			mysql_query("UPDATE contapagine SET accessi=accessi+1,ultimo=now() WHERE idpagina=$idp", $this->dbrw);
		} else {
			mysql_query("INSERT INTO contapagine SET idpagina=$idp,accessi=1,ultimo=now()", $this->dbrw);
		}
	}


	/**
	 * loggaBad()
	 * 
	 * Logga un tag errato
	 *
	 * @param string $tg URL errato
	 */
	function loggaBad($tg) {
		$tg = mysql_real_escape_string($tg, $this->dbrw);
		mysql_query("INSERT INTO errori SET dataora=NOW(),tag='$tg',ip='$_SERVER[REMOTE_ADDR]',url='" . $this->rquri . "',ref='" . $this->ref . "'", $this->dbrw);
	}


	/**
	 * eseguiMacro($tg)
	 * 
	 * Vengono eseguiti dei comandi in base ad un tag specifico.<br>
	 * La funzione e' richiamata da espandiLink()<br>
	 * Macro supportate:<br>
	 * - paginapiurecente: visualizza la data della pagina modificata piu' recentemente
	 * - legenda: visualizza la legenda delle abbreviazione delle tabelle degli episodi, pianeti, libri...
	 * - tab-xxx: tabella riassuntiva la cui idsezione e' xxx
	 * - randomquote: citazione casuale
	 * - elencoskin: elenco delle skin con i pulsanti di scelta
	 * - cloud: stampa la nuvola dei piu' visti
	 *
	 * @param string $tg macro da eseguire
	 * @return string l'output della macro
	 */
	function eseguiMacro($tg) {
		$b = '';
		// data della pagina modificata piu' recentemente
		if ('paginapiurecente' == $tg) {
			$mmr = mysql_query("SELECT lastmod FROM pagine ORDER BY lastmod DESC LIMIT 1", $this->dbro);
			$mr = mysql_fetch_array($mmr);
			$b= strftime('%A %d %B %Y, %H:%M:%S', $mr[0]);
		}
		// legenda delle abbreviazioni degli episodi, libri, pianeti
		if ('legenda' == $tg) {
			$mq = mysql_query("SELECT etichetta,descrizione,icona,categoria FROM episodicampi ORDER BY categoria,descrizione", $this->dbro);
			$oldcat = '*';
			while ($mr = mysql_fetch_array($mq)) {
				if ($oldcat != $mr['categoria']) {
					if ($oldcat != '*') {
						$b .= "\n</table>";
					}
					$b .= "\n<div class='legendaintestazione'>$mr[categoria]</div>";
					$b .= "\n<table class='legenda'>";
				}
				$oldcat = $mr['categoria'];
				$b .= "\n<tr><td class='legendaicona'>";
				if ('' != $mr['icona']) {
					$b .= $this->costruisciURLimmagineSkin($mr['icona'], $mr['etichetta']) . '>';
				} else {
					$b .= "<strong>$mr[etichetta]</strong>:";
				}
				$b .= "</td><td class='legendadesc'>" . $this->espandiLink($mr['descrizione']) . '</td></tr>';
			}
			$b .= "\n</table>";
		}
		// tabella riassuntiva di una serie
		if (substr($tg, 0, 3) == 'tab') {
			$idsezione = substr($tg,4);
			$b .= "<p>Questa visualizzazione &egrave; <strong>provvisoria</strong>, verr&agrave; migliorata in seguito.</p>";
			$b .= "\n<table class='tabellaepisodi' border='1' cellpadding='1'>";
			$b .= "\n<tr>";
			$b .= "<th><strong>Titolo US</strong></th>";
			$b .= "<th><strong>Prod.</strong></th>";
			$b .= "<th><strong>Seq.</strong></th>";
			$b .= "<th><strong>Data US</strong></th>";
			$b .= "<th><strong>Titolo IT</strong></th>";
			$b .= "\n</tr>";
			$qe = mysql_query("SELECT titolo,idpagina FROM pagine WHERE tipo=1 AND idsezione=$idsezione AND hidden=0", $this->dbro);
			while ($re = mysql_fetch_array($qe)) {
				$b .= "\n<tr>";
				//titolo US
				$b .= "\n<td>$re[titolo]</td>";
				//numero di produzione
				$qqd = mysql_query("SELECT valore FROM episodivalori WHERE idpagina=$re[idpagina] AND idcampo=42", $this->dbro);
				$qd = mysql_fetch_array($qqd);
				$b .= "\n<td>$qd[valore]</td>";
				//sequenza
				$qqd = mysql_query("SELECT valore FROM episodivalori WHERE idpagina=$re[idpagina] AND idcampo=1", $this->dbro);
				$qd = mysql_fetch_array($qqd);
				$b .= "\n<td>$qd[valore]</td>";
				//data US
				$qqd = mysql_query("SELECT valore FROM episodivalori WHERE idpagina=$re[idpagina] AND idcampo=2", $this->dbro);
				$qd = mysql_fetch_array($qqd);
				$b .= "\n<td>$qd[valore]</td>";
				//titolo IT
				$qqd = mysql_query("SELECT valore FROM episodivalori WHERE idpagina=$re[idpagina] AND idcampo=11", $this->dbro);
				$qd = mysql_fetch_array($qqd);
				$b .= "\n<td>$qd[valore]</td>";
				$b .= "\n</tr>";
			}
			$b .= "\n</table>";
		}
		// citazione casuale
		if ('randomquote' == $tg) {
			$ccr = mysql_query("SELECT idpagina,testo FROM capitoli WHERE idcapitolotipo=6 ORDER BY RAND() LIMIT 1", $this->dbro);
			$cr = mysql_fetch_array($ccr);
			$eer = mysql_query("SELECT titolo,tag FROM pagine WHERE idpagina=$cr[0]", $this->dbro);
			$er = mysql_fetch_array($eer);
			//sostituisco le classi con quelle apposite per l'homepage e sposto l'indicazione temporale
			ereg('<span class=\'tempo\'>Tempo: [0-9][0-9]:[0-9][0-9]</span><br>', $cr[1], $tempo);
			if (!$tempo) {
				ereg('<span class=\'tempo\'>Tempo: n.d.</span><br>', $cr[1], $tempo);
				$tempo2[0] = 'n.d.';
			} else { ereg('[0-9][0-9]:[0-9][0-9]', $tempo[0], $tempo2); }
			$sanitized = str_replace('citazione', 'citazionehp', str_replace($tempo[0], '', $cr[1]));
			$b .= "<strong>Citazione casuale</strong>:<br>" . $this->espandiLink($sanitized) . '<br>';
			$b .= '(' . $this->espandiLink('{' . $er[0] . '|' . $er[1] . '}') . ' - Tempo: ' . $tempo2[0] . ')';
		}
		// elenco skin
		if ('skin' == $tg) {
			$q = mysql_query("SELECT * FROM skin WHERE isvisibile=1 ORDER BY isdefault DESC,nome", $this->dbro);
			while ($r = mysql_fetch_array($q)) {
				$b .= "\n<div class='elencoskin'>";
				$b .= "<form name='$r[dir]' method='POST' action='" . $this->costruisciURL($this->aPagina['tag']) . "'>";
				$b .= "<strong>";
				$b .= "$r[nome]</strong> - $r[descrizione] ($r[autore]) ";
				if ($_SESSION['skin'] == $r['dir']) {
					// nulla
				} else {
					$b .= "<input type='hidden' name='skin' value='$r[dir]'>";
					$b .= "<input class='elencoskinbtn' type='submit' name='submit' value='Scegli questa skin!'></form>";
				}
				$b .= '</div>';
			}
		}
		// cloud
		if ('cloud' == $tg) {
			$atag = array();
			$q = mysql_query("SELECT idpagina,accessi FROM contapagine ORDER BY accessi DESC LIMIT " . $this->aSetup['cloudhm'], $this->dbrw);
			while ($r =  mysql_fetch_array($q)) {
				$rrd = mysql_query("SELECT tag FROM pagine WHERE idpagina='$r[idpagina]'", $this->dbro);
				$rr = mysql_fetch_array($rrd);
				if (('main' != $rr['tag']) AND ('404' != $rr['tag']) AND ('nuvolapagine' != $rr['tag']))  {
						$atag[$rr['tag']] = $r['accessi'];
				}
			}
			// calcolo il minimo e il massimo
			$maxval = max(array_values($atag));
			$minval = min(array_values($atag));
			// calcolo il range ed evito divisioni per zero
			$spread = $maxval - $minval;
			if (0 == $spread) $spread = 1;
			// calcolo gli step di incremento del font
			$step = ($this->aSetup['cloudpxmax'] - $this->aSetup['cloudpxmin']) / ($spread);
			// calcolo la nuvola
			$aout = array();
			foreach ($atag as $key => $value) {
				$size = round($this->aSetup['cloudpxmin'] + (($value - $minval) * $step));
				$rrd = mysql_query("SELECT titolondx FROM pagine WHERE tag='$key'", $this->dbro);
				$rr = mysql_fetch_array($rrd);
				$aout[] = '<span style="font-size: ' . $size . 'px;">' . '{' . $rr['titolondx'] . '|' . $key . '}</span> &bull; ';
			}
			// una bella agitatina
			shuffle($aout);
			$buffer = '';
			foreach ($aout as $o) {
				$buffer .= $this->espandiLink($o);
			}
			if ($buffer) {
				$buffer = substr($buffer, 0, -8);
			}
			$b .= $buffer;
		}
		return $b;
	}


	/**
	 * recurringCharacters()
	 * 
	 * Visualizza la pagina dei personaggi ricorrenti
	 *
	 * @todo migliorare la decisione della sezione da visualizzare
	 */
	function recurringCharacters() {
		$b = '';
		// stabilisco quale sia la sezione su cui filtrare le query
		// l'ID della sezione a cui viene assegnato $sezione e' quello degli episodi
		// calcolarlo cosi' e' poco elegante, ma e' veloce
		if (320 == $this->aPagina['idsezione']) {
			$sezione = 17;
		} elseif (352 == $this->aPagina['idsezione']) {
			$sezione = 18;
		} elseif (340 == $this->aPagina['idsezione']) {
			$sezione = 21;
		} elseif (345 == $this->aPagina['idsezione']) {
			$sezione = 1;
		} elseif (349 == $this->aPagina['idsezione']) {
			$sezione = 22;
		}
		$qrpers = mysql_query("SELECT guest.idpagina AS id,guest.idpaginapersonaggio AS idpgpers,pagine.idsezione,pgpers.titolo AS personaggio,
								pgpers.tag AS perstag,pgpers.chiavesort,COUNT(guest.idpaginapersonaggio) AS quanti
								FROM guest
								JOIN pagine ON guest.idpagina=pagine.idpagina
								JOIN pagine AS pgpers ON guest.idpaginapersonaggio=pgpers.idpagina
								WHERE pagine.idsezione=$sezione AND iscastfisso='0' 
								GROUP BY guest.idpaginapersonaggio
								ORDER BY quanti DESC, pgpers.chiavesort", $this->dbro);
		if (mysql_num_rows($qrpers) > 0) {
			$quanti = 100;
			$buf = '';
			// MySQL non accetta il risultato di COUNT() nella clausola WHERE
			while (($rpers = mysql_fetch_array($qrpers)) and ($quanti > 1)) {
				$quanti = $rpers['quanti'];
				if ($quanti > 2){
					$buf .= "\n<dl><dt><strong>" . '{' . $rpers['personaggio'] . '|' . $rpers['perstag'] . '}' . "</strong> ($rpers[quanti] episodi):</dt>\n<dd>";
					$qepers = mysql_query("SELECT guest.idpagina,guest.idpaginacast,pagine.titolondx AS episodio,pagine.tag
											FROM guest
											JOIN pagine ON guest.idpagina=pagine.idpagina
											WHERE guest.idpaginapersonaggio=$rpers[idpgpers] AND iscastfisso='0' 
											ORDER BY pagine.tag", $this->dbro);
					while ($epers = mysql_fetch_array($qepers)) {
						$buf .= '{' . $epers['episodio'] . '|' . $epers['tag'] . '}, ';
					}
					$buf = substr($buf, 0, -2);
					$buf .= "</dd>\n</dl>";
				}
			}	
			$b .= $this->espandiLink($buf);
		}
		return $b;
	}


	/**
	 * mappaDelSito()
	 * 
	 * Mappa del sito
	 *
	 */
	function mappaDelSito() {
		$b = '';
		$qs = mysql_query("SELECT node.nome, node.indextag, (COUNT(parent.nome) - 1) AS depth
							FROM sezioni AS node, sezioni AS parent
							WHERE node.sxmenu BETWEEN parent.sxmenu AND parent.dxmenu
							GROUP BY node.nome
							HAVING depth > 0 AND depth < 3
							ORDER BY node.sxmenu", $this->dbro);
		while ($rs = mysql_fetch_array($qs)) {
			$zz = "\n";
			if ('1' < $rs['depth']) {
				$zz .= "<div class='albero'>";
			} else {
				$zz .= "<div class='alberotitolo'>";
			}
			$zz .= '{' . $rs['nome'] . '|:' . $rs['indextag'] . '}</div>';
			$b .= $this->espandiLink($zz);
		}
		return $b;
	}


	/**
	 * hb5debug()
	 * 
	 * Funzione di servizio per la stampa di stringhe di debug
	 *
	 */
	function hb5debug($pre, $s) {
		$b .= "\n<!-- $pre - $s -->";
		return $b;
	}


	/**
	 * cronologiaB5()
	 * 
	 * Visualizzazione pagine della cronologia
	 *
	 */
	function cronologiaB5() {
		$b = '';
		$this->testiStandard();
		$b .= "\n<table border='0' class='cronologia'><tbody>";
		//estraggo le entry cronologiche
		$qrd = mysql_query("SELECT * FROM cronologia WHERE idpagina=" . $this->aPagina['idpagina'] . " ORDER BY anno,tordine", $this->dbro);
		while ($rd = mysql_fetch_array($qrd)) {
			$b .= "\n<tr><td class='cronologiaanno'>";
			if ('' == $rd['annodisplay']) {
				$b .= "&nbsp;";
			} else {
				$b .= $rd['annodisplay'];
			}
			$b .= "</td>";
			$b .= "\n<td class='cronologiatesto'>" . $this->espandiLink($rd['testo']) . "</td>";
			$b .= "\n<td class='cronologiafonte'>" . $this->espandiLink($rd['fonte']) . "</td></tr>";
		}
		$b .= "\n</tbody></table>";
		return $b;
	}


	/**
	 * scriviHomePage()
	 * 
	 * Visualizza la pagina di apertura del sito
	 *
	 */
	function scriviHomePage() {
		$b = '';
		//leggo i paragrafi di testo della prima pagina
		$t1 = '';
		$t2 = '';
		$i = 0;
		$qrd = mysql_query("SELECT * FROM testi WHERE idpagina=" . $this->aPagina['idpagina'] . " ORDER BY ordine", $this->dbro);
		//suddivido i paragrafi in due blocchi, da visualizzare rispettivamente prima e dopo le news
		while ($rd = mysql_fetch_array($qrd)){
			if (7 > $i) {
				if ('' == $rd['class']) {
					$t1 .= "\n<div class='testostandard'>";
				} else {
					$t1 .= "\n<div class='$rd[class]'>";
				}
				$t1 .= $this->espandiLink($rd['testo']) . "</div>";
			} else {
				if ('' == $rd['class']) {
					$t2 .= "\n<div class='testostandard'>";
				} else {
					$t2 .= "\n<div class='$rd[class]'>";
				}
				$t2 .= $this->espandiLink($rd['testo']) . "</div>";
			}
			$i++;
		}
		//estraggo e formatto le news
		$adesso = time();
		$nw = '';
		$nw = "\n<table border='0' width='100%' class='news'>";
		$nw .= "\n<tr><th width='50' colspan='2' class='newshead'><a name='news'>News</a></th></tr>";
		$qrd = mysql_query("SELECT * FROM news 
							WHERE pubblicazione<$adesso AND scadenza>$adesso 
							ORDER BY pubblicazione DESC", $this->dbro);
		if (mysql_num_rows($qrd) > 0) {
			while ($rd = mysql_fetch_array($qrd)) {
				switch ($rd['categoria']) {
				case '0':
					$nw .= "\n<tr class='newsriga'><td class='newsicona'>" . $this->costruisciURLImmagineSkin('news-b5.png', 'Babylon 5') . ">" . "</td>";
					break;
				case '1':
					$nw .= "\n<tr class='newsriga'><td class='newsicona'>" . $this->costruisciURLImmagineSkin('news-hb5.png', 'HyperB5') . ">" . "</td>";
					break;
				}
				$nw .= "\n<td class='newstesto'><strong>" . strftime('%d/%m/%Y', $rd['pubblicazione']) . ':</strong> ';
				$nw .= $this->espandiLink($rd['testo']) . '</td></tr>';
			}
		} else {
			$nw .= "\n<tr><td class='newstesto'>No News Is Good News.</td></tr>";
		}
		$nw .= "</table>";
		//sistemo tutto e scrivo la pagina
		$b .= $t1 . "\n" . $nw . "\n" . $t2;
		return $b;
	}


	/**
	 * novita()
	 * 
	 * Visualizza la pagina delle novit del sito
	 *
	 */
	function novita() {
		$b = '';
		$old = '*#*';
		//estraggo tutte le pagine create/modificate nel periodo di tempo definito in global.php, ad eccezione della stessa pagina delle novit
		$condizione = 'lastmod>(' . (time()-$this->aSetup['giornilast']) .')';
		//macello di query per estrarre anche la sezione di primo livello gerarchico corrispondente
		$qrd = mysql_query("SELECT lastmod,titolo,tag, (SELECT parent.nome
								FROM sezioni AS node,
								sezioni AS parent
								WHERE node.sxmenu BETWEEN parent.sxmenu AND parent.dxmenu
								AND node.idsezione = pagine.idsezione
								ORDER BY parent.sxmenu
								LIMIT 1,1) as nome
							FROM pagine
							JOIN sezioni ON pagine.idsezione = sezioni.idsezione
							WHERE $condizione AND (tag <> 'novita')
							ORDER BY lastmod DESC,chiavesort", $this->dbro);
		if (mysql_num_rows($qrd) > 0) {
			$b .= "\n<table class='novita'><tbody>";
			while ($rd = mysql_fetch_array($qrd)) {
				$oggi = strftime('%d/%m/%Y:', $rd['lastmod']);
				// rottura
				if ($oggi != $old){
					if ('*#*' != $old) {
						//tolgo l'ultimo <br> che  di troppo e chiudo la linea
						$b = substr($b, 0, -4);
						$b .= '</td></tr>';
					}
					$b .= "\n<tr class='novitariga'><td class='novitadata'>$oggi</td>";
					$b .= "\n<td class='novitapag'>";
					$old = $oggi;
				}
				if ('main' != $rd['tag']) {
					$b .= "\n" . $this->espandiLink( '{' . $rd['nome'] . " * " . $rd['titolo'] . '|' . $rd['tag'] . '}') . '<br>';
				} else {
					$b .= "\n" . $this->espandiLink( '{' . $rd['titolo'] . '|copertina}') . '<br>';
				}
			}
			//tolgo l'ultimo <br> che  di troppo e chiudo la tabella
			$b = substr($b, 0, -4);
			$b .= "\n</td></tr></tbody></table>";
		} else {
			$b .= "<div class='testostandard'>Nessuna pagina aggiornata nell'ultimo mese.</div>";
		}
		$b .= "<div class='testostandard'>Data e ora dell'ultimo aggiornamento del sito: " . $this->eseguiMacro('paginapiurecente') . "</div>";
		return $b;
	}


	/**
	 * readSetup($tag)
	 * 
	 * Legge un valore dalla tabella di setup
	 *
	 * @param string $tag tag da leggere
	 * 
	 */
	function readSetup($tag) {
		$b = '';
		$rd = mysql_query("SELECT * FROM setup WHERE tag='$tag'", $this->dbro);
		$r = mysql_fetch_array($rd);
		$b = trim($r['valore']);
		return $b;
	}


	/**
	 * readStore($tag)
	 * 
	 * Legge un valore dalla tabella di store
	 *
	 * @param string $tag tag da leggere
	 * 
	 */
	function readStore($tag) {
		$b = '';
		$rd = mysql_query("SELECT * FROM store WHERE tag='$tag'", $this->dbrw);
		$r = mysql_fetch_array($rd);
		$b = trim($r['valore']);
		return $b;
	}


	/**
	 * writeStore($tag, $valore)
	 * 
	 * Scrive un valore dalla tabella di store
	 *
	 * @param string $tag tag da scrivere
	 * @param string $valore valore da scrivere
	 * 
	 */
	function writeStore($tag, $valore) {
		$valore = mysql_real_escape_string($valore, $this->dbrw);
		mysql_query("UPDATE store SET valore='$valore' WHERE tag='$tag'", $this->dbrw);
	}


	/**
	 * aggiornaUltimi()
	 * 
	 * Aggiorna le statistiche delle ultime modifiche e ricrea il file XML delle ultime modifiche
	 *
	 */
	function aggiornaUltimi() {
		$timetag = date('ymdH');
		if ($timetag != $this->readStore('tsrss')) {
			$this->writeStore('tsrss', $timetag);
			// facciamo pulizia
			$condizione = 'lastmod>(' . (time()-$this->aSetup['giornilast']) .')';
			// pagine normali
			$q = mysql_query("SELECT lastmod,titolo,tag,nome
								FROM pagine
								JOIN sezioni ON pagine.idsezione = sezioni.idsezione
								WHERE $condizione AND hidden='0' AND (tag <> 'novita')
								ORDER BY lastmod DESC,chiavesort", $this->dbro);
			//e ora scrivo il file XML per il feed
			$buf = "<?xml version=\"1.0\"?>\n";
			$buf .= "<rss version=\"2.0\">\n";
			$buf .= "<channel>\n";
			$buf .= "<title>HyperB5: ultimi aggiornamenti</title>\n";
			$buf .= "<description>Elenco delle pagine aggiornate negli ultimi " . $this->aSetup['giornilast']/86400 . " giorni</description>\n";
			$buf .= "<link>http://www.hyperb5.info</link>\n";
			$buf .= "<language>it-it</language>\n";
			$buf .= "<pubDate>" . date('r') . "</pubDate>\n";
			$buf .= "<lastBuildDate>" . date('r') . "</lastBuildDate>\n";
			$buf .= "<generator>HyperB5-NG Content Engine v" . $this->aSetup['versione'] . "</generator>\n\n";
			$buf .= "<ttl>70</ttl>\n\n";
			$trans = get_html_translation_table(HTML_ENTITIES);
			while ($r = mysql_fetch_array($q)) {
				$buf .= "\n<item>\n";
				$buf .= " <title>" . strtr(strip_tags($r['titolo']),$trans) . "</title>\n";
				$buf .= " <description>" . strtr(strip_tags($r['titolo']),$trans) . "</description>\n";
				$buf .= " <category>" . $r['nome'] . "</category>\n";
				$buf .= " <link>http://www.hyperb5.info/index.php/$r[tag]</link>\n";
				$buf .= " <guid>http://www.hyperb5.info/index.php/$r[tag]</guid>\n";
				$buf .= " <pubDate>" . date('r', $r['lastmod']) . "</pubDate>\n";
				$buf .= "</item>\n";
			}
			$buf .= "</channel>\n";
			$buf .= "</rss>\n";
			if (!$hndl = fopen($this->aSetup['rsslast'], "w")) { exit; }
			fwrite($hndl, $buf);
			fclose($hndl);
		}
	}


	/**
	 * ultime10Pagine()
	 * 
	 * Aggiunge ai link a destra le ultime 10 pagine modificate
	 *
	 */
	function ultime10Pagine() {
		$q = mysql_query("SELECT tag,titolondx FROM pagine WHERE hidden='0' ORDER BY lastmod DESC LIMIT 10", $this->dbro);
		while ($r = mysql_fetch_array($q)) {
			$this->aggiungiRiferimento('Ultime dieci pagine modificate', $this->espandiLink('{' . $r['titolondx'] . '|' . $r['tag'] . '}'));
		}
	}


	/**
	 * stripLink($testo)
	 * 
	 * Analizza il testo in input e lo restituisce in output togliendo i link nelle sequenze tra parentesi graffe ma senza espanderli
	 * 
	 * @param string $testo testo da analizzare
	 *
	 */
	function stripLink($testo) {
		preg_match_all( "!(\{[^\{]+\})!i" , $testo , $aMatch );
		for ($i = 0; $i < count ($aMatch[1]); $i++)  {
			//toglie le parentesi graffe
			$sanitized = preg_replace("!(\{|\})!" , "" , $aMatch[1][$i]);
			// explode e' piu' veloce
			list ($hot, $tag) = explode('|' , $sanitized);
			$newb = trim($hot);
			$testo = str_replace( $aMatch[1][$i] , $newb, $testo);
		}
		return $testo;
	}

	
}

?>
