-- phpMyAdmin SQL Dump
-- version 3.1.2
-- http://www.phpmyadmin.net
--

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `hb5-1`
--
DROP DATABASE `hb5-1`;
CREATE DATABASE `hb5-1` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;
USE `hb5-1`;

-- --------------------------------------------------------

--
-- Struttura della tabella `capitoli`
--

DROP TABLE IF EXISTS `capitoli`;
CREATE TABLE IF NOT EXISTS `capitoli` (
  `idcapitolo` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica un capitolo',
  `idpagina` int(10) unsigned NOT NULL default '0' COMMENT 'ID della pagina che ospita il capitolo - numero specificato come idpagina nella tabella pagine',
  `idcapitolotipo` int(10) unsigned NOT NULL default '0' COMMENT 'ID del tipo di capitolo - numero specificato come idcapitolotipo nella tabella capitolitipi',
  `testo` text NOT NULL COMMENT 'testo del capitolo',
  `ordine` smallint(5) unsigned NOT NULL default '1',
  `taginclude` varchar(250) default NULL COMMENT 'tag per i riferimenti inversi',
  PRIMARY KEY  (`idcapitolo`),
  KEY `idpagina` (`idpagina`),
  KEY `ordine` (`ordine`),
  KEY `idcapitolotipo` (`idcapitolotipo`),
  FULLTEXT KEY `testo` (`testo`),
  FULLTEXT KEY `taginclude` (`taginclude`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='dati generici facenti parte di varie pagine del sito, divisi';

-- --------------------------------------------------------

--
-- Struttura della tabella `capitolitipi`
--

DROP TABLE IF EXISTS `capitolitipi`;
CREATE TABLE IF NOT EXISTS `capitolitipi` (
  `idcapitolotipo` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica un tipo di capitolo',
  `ordine` smallint(5) unsigned NOT NULL default '1',
  `intestazione` varchar(50) NOT NULL COMMENT 'nome del tipo di capitolo visualizzato nella pagina html',
  `tag` varchar(20) NOT NULL default '',
  `descrizione` varchar(150) NOT NULL COMMENT 'descrizione del tipo di capitolo',
  `isbullet` tinyint(3) unsigned NOT NULL default '1' COMMENT '1=yes -- Se il tipo di capitolo prevede una struttura ad elenco puntato mettere 1',
  PRIMARY KEY  (`idcapitolotipo`),
  KEY `ordine` (`ordine`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='tipi di capitolo, ad esempio Trama, Citazioni, YATI, Doppiag';

-- --------------------------------------------------------

--
-- Struttura della tabella `castfisso`
--

DROP TABLE IF EXISTS `castfisso`;
CREATE TABLE IF NOT EXISTS `castfisso` (
  `idcastfisso` int(10) unsigned NOT NULL auto_increment,
  `serie` char(3) NOT NULL COMMENT 'serie in cui l''attore fa parte del cast fisso, intesa come la relativa idsezione specificata nella tabella sezioni',
  `idcast` int(10) unsigned NOT NULL COMMENT 'riferimento all''attore che interpreta il personaggio tramite indicazione dello idpagina della pagina dedicata all''attore',
  `idpersonaggio` int(10) unsigned NOT NULL COMMENT 'riferimento al personaggio tramite indicazione dello idpagina della pagina dedicata a tale personaggio',
  `stagione` tinyint(3) unsigned NOT NULL COMMENT 'numero di stagione alla quale si fa riferimento',
  `personaggio` varchar(200) NOT NULL default '' COMMENT 'nome del personaggio se diverso da quello indicato nella pagina idpaginapersonaggio. Se nella stringa c''Š un @@@ al suo posto verr… messo il nome del personaggio preso da idpaginapersonaggio',
  `linkserie` varchar(50) NOT NULL default '' COMMENT 'link alla serie cui si fa riferimento, ad esempio: {Babylon 5|:b5}',
  PRIMARY KEY  (`idcastfisso`),
  KEY `serie` (`serie`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- --------------------------------------------------------

--
-- Struttura della tabella `cronologia`
--

DROP TABLE IF EXISTS `cronologia`;
CREATE TABLE IF NOT EXISTS `cronologia` (
  `idcronologia` int(11) unsigned NOT NULL auto_increment,
  `anno` int(15) NOT NULL default '0',
  `annodisplay` varchar(40) default NULL COMMENT 'anno che viene mostrato nella pagina html',
  `tordine` smallint(5) unsigned NOT NULL default '10' COMMENT 'ordine dell''entry cronologica nel dato anno',
  `testo` text NOT NULL,
  `fonte` text NOT NULL,
  `idpagina` int(10) unsigned NOT NULL default '0' COMMENT 'ID della pagina in cui va inserita l''entry cronologica - numero specificato come idpagina nella tabella pagine',
  `lastmod` int(10) unsigned NOT NULL default '1' COMMENT 'UNIX date ultima modifica',
  PRIMARY KEY  (`idcronologia`),
  KEY `anno` (`anno`),
  KEY `ordine` (`anno`,`tordine`),
  KEY `lastmod` (`lastmod`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `episodicampi`
--

DROP TABLE IF EXISTS `episodicampi`;
CREATE TABLE IF NOT EXISTS `episodicampi` (
  `idcampo` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica il campo di un episodio (pianeta, libri, ecc...)',
  `etichetta` varchar(40) NOT NULL default '' COMMENT 'etichetta del campo, ad es. SEQ',
  `ordine` smallint(5) unsigned NOT NULL default '1',
  `descrizione` varchar(250) NOT NULL default '',
  `categoria` varchar(20) NOT NULL default '' COMMENT 'Categoria del campo -- Esempio: Episodi, Libri, Pianeti',
  `icona` varchar(50) NOT NULL COMMENT 'nome del file immagine usato come icona del campo',
  PRIMARY KEY  (`idcampo`),
  KEY `ordine` (`ordine`),
  KEY `etichetta` (`etichetta`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='tipi di campi degli episodi (e non solo)';

-- --------------------------------------------------------

--
-- Struttura della tabella `episodivalori`
--

DROP TABLE IF EXISTS `episodivalori`;
CREATE TABLE IF NOT EXISTS `episodivalori` (
  `idvalore` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica il singolo valore inserito in un dato campo',
  `idcampo` int(10) unsigned NOT NULL default '0' COMMENT 'ID del campo cui appartiene il valore - numero specificato come idcampo nella tabella episodicampi',
  `valore` varchar(100) default NULL COMMENT 'numero o stringa di testo da inserire nel tot campo della tot pagina -- Esempio: The Gathering',
  `idpagina` int(10) unsigned NOT NULL default '0' COMMENT 'ID della pagina in cui va inserito il campo di cui si sta specificando il valore - numero specificato come idpagina nella tabella pagine',
  `ordine` smallint(5) unsigned NOT NULL default '1',
  `idpaginacast` int(10) unsigned NOT NULL default '0' COMMENT 'ID della pagina dell''attore collegato al campo di cui si sta specificando il valore - numero specificato come idpagina nella tabella pagine',
  `chiavesortita` varchar(30) NOT NULL default '' COMMENT 'campo da usare come sort per il titolo italiano -- Esempio: Cielo pieno di stelle, un',
  PRIMARY KEY  (`idvalore`),
  KEY `idpagina` (`idpagina`),
  KEY `ordine` (`ordine`),
  KEY `idpaginacast` (`idpaginacast`),
  KEY `chiavesortita` (`chiavesortita`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='valori dei campi';

-- --------------------------------------------------------

--
-- Struttura della tabella `guest`
--

DROP TABLE IF EXISTS `guest`;
CREATE TABLE IF NOT EXISTS `guest` (
  `idguest` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica un singolo guest di un episodio',
  `ordine` smallint(5) unsigned NOT NULL default '1',
  `idpaginapersonaggio` int(10) unsigned NOT NULL default '0' COMMENT 'riferimento al personaggio tramite indicazione dello idpagina della pagina dedicata a tale personaggio',
  `idpaginacast` int(10) unsigned NOT NULL default '0' COMMENT 'riferimento all''attore che interpreta il personaggio tramite indicazione dello idpagina della pagina dedicata all''attore',
  `idpagina` int(10) unsigned NOT NULL default '0' COMMENT 'id della pagina in cui compare il personaggio e il relativo attore specificati negli altri campi - numero specificato come idpagina nella tabella pagine',
  `personaggio` varchar(200) NOT NULL default '' COMMENT 'nome del personaggio se diverso da quello indicato nella pagina idpaginapersonaggio. Se nella stringa c''è un @@@ al suo posto verrà messo il nome del personaggio preso da idpaginapersonaggio',
  `nomeattore` varchar(80) NOT NULL default '' COMMENT 'nome attore SOLO se diverso da quello della relativa pagina',
  `uncredited` tinyint(3) unsigned NOT NULL default '0' COMMENT 'se l''apparizione non ha il credit nella sigla, mettere 1',
  `iscastfisso` tinyint(3) unsigned NOT NULL default '0' COMMENT 'se l''attore e il relativo personaggio fanno parte del cast fisso, mettere 1',
  `creditonly` tinyint(3) unsigned NOT NULL default '0' COMMENT 'se c''è il credit nella sigla ma non appare, mettere 1 (usare solo per il cast fisso)',
  PRIMARY KEY  (`idguest`),
  KEY `ordine` (`ordine`),
  KEY `idpagina` (`idpagina`),
  KEY `idcast` (`idpaginacast`),
  KEY `idpersonaggio` (`idpaginapersonaggio`),
  KEY `personaggio` (`personaggio`),
  KEY `nomeattore` (`nomeattore`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 ROW_FORMAT=DYNAMIC;

-- --------------------------------------------------------

--
-- Struttura della tabella `immagini`
--

DROP TABLE IF EXISTS `immagini`;
CREATE TABLE IF NOT EXISTS `immagini` (
  `idimmagine` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica una immagine',
  `file` varchar(50) NOT NULL default '' COMMENT 'URL dell''immagine relativo alla directory principale del sito',
  `larghezza` smallint(5) unsigned NOT NULL default '0',
  `altezza` smallint(5) unsigned NOT NULL default '0',
  `descrizione` varchar(150) NOT NULL default '',
  `imgtag` varchar(20) NOT NULL default '' COMMENT 'tag dell''immagine per selezionarla rapidamente senza ricordare lo idimmagine',
  PRIMARY KEY  (`idimmagine`),
  KEY `descrizione` (`descrizione`),
  KEY `imgtag` (`imgtag`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `immaginidata`
--

DROP TABLE IF EXISTS `immaginidata`;
CREATE TABLE IF NOT EXISTS `immaginidata` (
  `idimmaginedata` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica una immaginedata',
  `tag` varchar(30) NOT NULL COMMENT 'tag assegnato all''immagine - Può essere uguale per più immagini che rappresentano lo stesso oggetto/situazione',
  `idimmagine` int(10) unsigned NOT NULL COMMENT 'id della immagine - numero specificato come idimmagine nella tabella immagini',
  `mesegiorno` varchar(5) NOT NULL default '*' COMMENT 'mm-gg, asterisco se default o rand per random',
  PRIMARY KEY  (`idimmaginedata`),
  KEY `mesegiorno` (`mesegiorno`),
  KEY `tag` (`tag`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='immagini che cambiano al cambiare della data';

-- --------------------------------------------------------

--
-- Struttura della tabella `immaginipagine`
--

DROP TABLE IF EXISTS `immaginipagine`;
CREATE TABLE IF NOT EXISTS `immaginipagine` (
  `idimmaginepagina` int(11) NOT NULL auto_increment COMMENT 'indice univoco che identifica una immaginepagina',
  `idimmagine` int(10) unsigned default '0' COMMENT 'id della immagine - numero specificato come idimmagine nella tabella immagini',
  `idpagina` int(10) unsigned NOT NULL default '0' COMMENT 'ID della pagina in cui va inserita l''immagine - numero specificato come idpagina nella tabella pagine',
  `ordine` smallint(5) unsigned NOT NULL default '1',
  `tagrotante` varchar(30) default NULL,
  PRIMARY KEY  (`idimmaginepagina`),
  KEY `idpagina` (`idpagina`),
  KEY `ordine` (`ordine`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 ROW_FORMAT=FIXED;

-- --------------------------------------------------------

--
-- Struttura della tabella `listaepisodi`
--

DROP TABLE IF EXISTS `listaepisodi`;
CREATE TABLE IF NOT EXISTS `listaepisodi` (
  `idlistaepisodio` int(11) NOT NULL auto_increment COMMENT 'indice univoco che identifica un listaepisodi',
  `idpagina` int(10) unsigned default '0' COMMENT 'id della pagina di un episodio - numero specificato come idpagina nella tabella pagine',
  `serie` int(10) unsigned default '0' COMMENT 'id serie di riferimento - numero specificato come idsezione nella tabella sezioni',
  `stagione` char(1) NOT NULL default '' COMMENT 'numero di stagione, P = pilot',
  `ordinetrasmissione` smallint(5) unsigned NOT NULL default '0' COMMENT 'ordine di trasmissione dello specifico episodio',
  `ordineproduzione` smallint(5) unsigned NOT NULL default '0' COMMENT 'ordine di produzione dello specifico episodio',
  `ordineconsigliato` smallint(5) unsigned NOT NULL default '0' COMMENT 'ordine consigliato dello specifico episodio',
  PRIMARY KEY  (`idlistaepisodio`),
  KEY `serie` (`serie`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `news`
--

DROP TABLE IF EXISTS `news`;
CREATE TABLE IF NOT EXISTS `news` (
  `idnews` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica una news',
  `pubblicazione` int(10) unsigned NOT NULL default '0' COMMENT 'unix date di pubblicazione',
  `scadenza` int(10) unsigned NOT NULL default '0' COMMENT 'unix date di scadenza',
  `testo` text NOT NULL,
  `categoria` tinyint(3) unsigned NOT NULL default '0' COMMENT '0 = B5 News, 1 = HB5 News',
  PRIMARY KEY  (`idnews`),
  KEY `pubblicazione` (`categoria`,`pubblicazione`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `pagine`
--

DROP TABLE IF EXISTS `pagine`;
CREATE TABLE IF NOT EXISTS `pagine` (
  `idpagina` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica una pagina',
  `tag` varchar(30) NOT NULL default '' COMMENT 'tag mnemonico, usato anche nell''url --- Esempio: doohanjames',
  `lastmod` int(10) unsigned NOT NULL default '0' COMMENT 'UNIX date ultima modifica',
  `idsezione` int(10) unsigned NOT NULL default '0' COMMENT 'ID della sezione della pagina - numero specificato come idsezione nella tabella sezioni',
  `titolo` varchar(80) NOT NULL default '' COMMENT 'titolo',
  `tipo` tinyint(3) unsigned NOT NULL default '0' COMMENT 'tipo di layout, vedi $tipopagina in include/global.php per la descrizione',
  `titolondx` varchar(80) NOT NULL default '' COMMENT 'titolo della pagina che apparirà nell''indice -- Esempio: James Doohan',
  `chiavesort` varchar(30) NOT NULL default '' COMMENT 'campo da usare come sort -- Esempio: Doohan, James',
  `imdb` varchar(50) NOT NULL default '' COMMENT 'URL IMDB',
  `tagprima` varchar(30) NOT NULL default '' COMMENT 'tag della pagina precedente',
  `tagdopo` varchar(30) NOT NULL default '' COMMENT 'tag della pagina successiva',
  `hidden` tinyint(3) unsigned NOT NULL default '0' COMMENT '1=hidden',
  `originale` varchar(80) default NULL COMMENT 'nome originale inglese',
  PRIMARY KEY  (`idpagina`),
  UNIQUE KEY `tag` (`tag`),
  KEY `lastmod` (`lastmod`),
  KEY `titolo` (`titolo`),
  KEY `chiavesort` (`chiavesort`),
  KEY `sezione` (`idsezione`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='master table ';

-- --------------------------------------------------------

--
-- Struttura della tabella `ridirezioni`
--

DROP TABLE IF EXISTS `ridirezioni`;
CREATE TABLE IF NOT EXISTS `ridirezioni` (
  `idridirezione` int(10) unsigned NOT NULL auto_increment,
  `da` varchar(30) default NULL,
  `a` varchar(30) default NULL,
  PRIMARY KEY  (`idridirezione`),
  KEY `da` (`da`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `riferimenti`
--

DROP TABLE IF EXISTS `riferimenti`;
CREATE TABLE IF NOT EXISTS `riferimenti` (
  `idriferimento` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica un riferimento',
  `idpagina` int(10) unsigned NOT NULL default '0' COMMENT 'ID della pagina in cui va inserito il riferimento in oggetto - numero specificato come idpagina nella tabella pagine',
  `categoria` varchar(25) NOT NULL default '' COMMENT 'categoria del riferimento --  Esempio: Episodi, Astronavi, Specie...',
  `riferimento` varchar(200) NOT NULL default '' COMMENT 'riferimento -- Esempio: {Ragesh 3|ragesh3}',
  `backlink` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`idriferimento`),
  KEY `idpagina` (`idpagina`),
  KEY `catrif` (`categoria`,`riferimento`),
  KEY `backlink` (`backlink`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `setup`
--

DROP TABLE IF EXISTS `setup`;
CREATE TABLE IF NOT EXISTS `setup` (
  `tag` varchar(30) NOT NULL default '',
  `valore` varchar(100) default NULL,
  PRIMARY KEY  (`tag`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `sezioni`
--

DROP TABLE IF EXISTS `sezioni`;
CREATE TABLE IF NOT EXISTS `sezioni` (
  `idsezione` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica una sezione',
  `sigla` varchar(30) NOT NULL default '',
  `riferimento` varchar(30) NOT NULL default '' COMMENT 'nome che verrà visualizzato nei riferimenti come titolo per le pagine appartenenti alla sezione',
  `nome` varchar(60) NOT NULL,
  `indextag` varchar(20) NOT NULL default '' COMMENT 'tag per il richiamo dal link :xxx',
  `tipoindice` tinyint(3) unsigned NOT NULL default '0' COMMENT 'tipo di indice, vedi $tipoindice in include/global.php per la descrizione',
  `sxmenu` tinyint(3) unsigned NOT NULL default '0' COMMENT 'identificatore per la creazione del menu secondo il modello nested set: valore a sinistra',
  `dxmenu` tinyint(3) unsigned NOT NULL default '0' COMMENT 'identificatore per la creazione del menu secondo il modello nested set: valore a destra',
  `idsezionebreadcrumb` int(10) unsigned NOT NULL default '0' COMMENT 'vale 0 se la sezione genera il breadcrumb, oppure contiene l''idsezione della sezione che lo fa',
  `sxbreadcrumb` tinyint(3) unsigned NOT NULL default '0' COMMENT 'identificatore per la creazione del breadcrumb secondo il modello nested set: valore a sinistra - vale 0 se idsezionebreadcrumb=0',
  `dxbreadcrumb` tinyint(3) unsigned NOT NULL default '0' COMMENT 'identificatore per la creazione del breadcrumb secondo il modello nested set: valore a destra - vale 0 se idsezionebreadcrumb=0',
  `icona` varchar(50) NOT NULL COMMENT 'nome del file immagine usato come icona della sezione',
  PRIMARY KEY  (`idsezione`),
  KEY `indextag` (`indextag`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `skin`
--

DROP TABLE IF EXISTS `skin`;
CREATE TABLE IF NOT EXISTS `skin` (
  `idskin` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica una skin',
  `isdefault` tinyint(3) unsigned NOT NULL COMMENT 'se skin di default valorizzare a 1 - deve essercene almeno una',
  `dir` varchar(20) NOT NULL COMMENT 'directory nella quale si trova la skin',
  `nome` varchar(50) NOT NULL COMMENT 'nome della skin',
  `descrizione` text NOT NULL COMMENT 'descrizione della skin',
  `autore` varchar(100) NOT NULL COMMENT 'autore della skin',
  `isvisibile` tinyint(3) unsigned NOT NULL default '0' COMMENT 'se visibile in elenco skin valorizzare a 1',
  PRIMARY KEY  (`idskin`),
  UNIQUE KEY `dir` (`dir`),
  KEY `isdefault` (`isdefault`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `tabelle`
--

DROP TABLE IF EXISTS `tabelle`;
CREATE TABLE IF NOT EXISTS `tabelle` (
  `idtabella` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica una tabella',
  `ttag` varchar(20) NOT NULL default '' COMMENT 'tag univoco che identifica una tabella',
  `tordine` smallint(5) unsigned NOT NULL default '0' COMMENT 'ordine della riga in oggetto nella tabella',
  `prima` text NOT NULL COMMENT 'testo prima colonna della riga in oggetto',
  `seconda` text NOT NULL COMMENT 'testo seconda colonna della riga in oggetto',
  `terza` text COMMENT 'testo terza colonna della riga in oggetto',
  `quarta` text COMMENT 'testo quarta colonna della riga in oggetto',
  `istitolo` tinyint(3) unsigned NOT NULL default '0' COMMENT 'Se la riga in oggetto è quella del titolo della tabella: 1=yes',
  `qualicenter` char(4) default NULL,
  PRIMARY KEY  (`idtabella`),
  KEY `ordine` (`tordine`),
  KEY `tag` (`ttag`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `testi`
--

DROP TABLE IF EXISTS `testi`;
CREATE TABLE IF NOT EXISTS `testi` (
  `idtesto` int(10) unsigned NOT NULL auto_increment COMMENT 'indice univoco che identifica un dato testo',
  `idpagina` int(10) unsigned NOT NULL default '0' COMMENT 'ID della pagina in cui va inserito il testo in oggetto - numero specificato come idpagina nella tabella pagine',
  `testo` text NOT NULL COMMENT 'testo da inserire',
  `ordine` smallint(5) unsigned NOT NULL default '0',
  `class` varchar(20) NOT NULL default '' COMMENT 'eventuale classe da CSS con la quale il testo va visualizzato',
  PRIMARY KEY  (`idtesto`),
  KEY `ordine` (`ordine`),
  KEY `idpagina` (`idpagina`),
  FULLTEXT KEY `testo` (`testo`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='dati generici';


--
-- Database: `hb5-2`
--
DROP DATABASE `hb5-2`;
CREATE DATABASE `hb5-2` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;
USE `hb5-2`;

-- --------------------------------------------------------

--
-- Struttura della tabella `cerca`
--

DROP TABLE IF EXISTS `cerca`;
CREATE TABLE IF NOT EXISTS `cerca` (
  `dataora` timestamp NOT NULL default '0000-00-00 00:00:00',
  `cerca` varchar(30) NOT NULL,
  `trovati` int(11) default NULL,
  `ip` varchar(15) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `contapagine`
--

DROP TABLE IF EXISTS `contapagine`;
CREATE TABLE IF NOT EXISTS `contapagine` (
  `idpagina` int(11) NOT NULL default '0',
  `accessi` int(10) unsigned NOT NULL default '0',
  `ultimo` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`idpagina`),
  KEY `accessi` (`accessi`),
  KEY `ultimo` (`ultimo`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `errori`
--

DROP TABLE IF EXISTS `errori`;
CREATE TABLE IF NOT EXISTS `errori` (
  `dataora` timestamp NOT NULL default '0000-00-00 00:00:00',
  `tag` varchar(30) NOT NULL default '',
  `ip` varchar(15) NOT NULL default '',
  `url` varchar(200) NOT NULL default '',
  `ref` varchar(200) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `store`
--

DROP TABLE IF EXISTS `store`;
CREATE TABLE IF NOT EXISTS `store` (
  `tag` varchar(10) NOT NULL default '',
  `valore` varchar(30) default NULL,
  PRIMARY KEY  (`tag`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Struttura della tabella `ultimi`
--

DROP TABLE IF EXISTS `ultimi`;
CREATE TABLE IF NOT EXISTS `ultimi` (
  `lastmod` int(10) unsigned NOT NULL,
  `riga` varchar(250) NOT NULL default ' ',
  `idsezione` int(10) unsigned NOT NULL,
  `titolo` varchar(200) default NULL,
  `tag` varchar(50) default NULL,
  KEY `riga` (`riga`,`lastmod`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
